#include <hmg.ch>

declare window HGF120
declare window HGF122

Function HGF122_OnInit()
   local aCode   
   HGF122.List_1.DeleteAllItems()
   aCode := aCodes[ascan(aCodes, {|x|x[1] == "CTRLTYPE"}), 2]
   for n := 1 to len(aCode)
      HGF122.List_1.AddItem(aCode[n, 4])
   next
   HGF122.List_1.Value := GridComboLookupValue("CTRLTYPE", "Textbox")
Return nil

Function HGF122_OnSelect()
   local cCode := GridComboGetCode("CTRLTYPE", HGF122.List_1.Value), item1, seqno
   item1 := HGF120.grid_1.Item(HGf120.grid_1.ItemCount)
   seqno := item1[14] + 1
   do case
      case cCode == "Textbox"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Textbox"),"",HGF120.BASEOBJECT.Value,"","",1,2,0,GridComboLookupValue("ALIGNMENT", "n/a"),"n/a",2,3,20,seqno,0})
      case cCode == "Combobox"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Combobox"),"",HGF120.BASEOBJECT.Value,"","",1,2,0,GridComboLookupValue("ALIGNMENT", "n/a"),"",2,3,20,seqno,0})
      case cCode == "Checkbox"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Checkbox"),"",HGF120.BASEOBJECT.Value,"","",1,2,0,GridComboLookupValue("ALIGNMENT", "n/a"),"",2,3,20,seqno,0})
      case cCode == "Datepicker"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Datepicker"),"",HGF120.BASEOBJECT.Value,"","",1,2,0,GridComboLookupValue("ALIGNMENT", "n/a"),"n/a",2,3,20,seqno,0})
      case cCode == "Frame"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Frame"),"","n/a","n/a","n/a",1,3,0,GridComboLookupValue("ALIGNMENT", "n/a"),"n/a",3,3,20,seqno,0})
      case cCode == "Grid"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Grid"),"","","grid_1","n/a",3,1,0,GridComboLookupValue("ALIGNMENT", "n/a"),"n/a",3,3,20,seqno,0})
      case cCode == "Button"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Button"),"","n/a","","n/a",1,2,0,GridComboLookupValue("ALIGNMENT", "Bottom right"),"n/a",3,1,20,seqno,0})
      case cCode == "Column textbox"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Column textbox"),"",HGF120.BASEOBJECT.Value,"","",3,3,100,GridComboLookupValue("ALIGNMENT", "n/a"),"n/a",3,3,20,seqno,0})
      case cCode == "Column combobox"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Column combobox"),"",HGF120.BASEOBJECT.Value,"","",3,3,100,GridComboLookupValue("ALIGNMENT", "n/a"),"n/a",3,3,20,seqno,0})
      case cCode == "Column datepicker"
         HGF120.grid_1.AddItem({GridComboLookupValue("CTRLTYPE", "Column datepicker"),"",HGF120.BASEOBJECT.Value,"","",3,3,100,GridComboLookupValue("ALIGNMENT", "n/a"),"n/a",3,3,20,seqno,0})
   endcase
   HGF120.grid_1.value := HGF120.grid_1.ItemCount
   HGF122.Hide
   HGF122.release
Return nil

