/*
This source code has been generated with HMGGEN - Harbour Application Generator.
Please do not remove the BEGIN and END tags and place your own code between the
predefined BEGIN and END tags.
*/

#include "hmg.ch"

declare window HGR110
/* BEGIN */
/* END */

function HGR110_OnInit()
    local n, aObjects := {}, oProductChoice
    HGR110.grid_1.DeleteAllItems
/* BEGIN */
/*
   Notes:
   After generating hgr110.fmg update this file with IDE manually
   - ColumnHeaders -> if(language=1,'Choice description','Choice description (English)')
*/
   aObjects := ProductChoices():Find(nApplid, {})
/* END */
    for n := 1 to len(aObjects)
        oProductChoice := aObjects[n]
        HGR110.grid_1.AddItem({ ;
            oProductChoice:nameTable, ;
            oProductChoice:codeChoice, ;
            if(language = 1, oProductChoice:descrChoice, oProductChoice:descrChoiceEnglish), ;
            if(oProductChoice:indicDefaultChoice = "Y", 1, 2), ;
            if(oProductChoice:indicCommercialDecision = "Y", 1, 2), ;
            oProductChoice:nameReferenceTable, ;
            oProductChoice:codeReferenceChoice, ;
            oProductChoice:numberSequence, ;
            oProductChoice:id ;
        })
    next
/* BEGIN */
   /*   
   Notes:
   After generating update this file with IDE manually
            if(language = 1, oProductChoice:descrChoice, oProductChoice:descrChoiceEnglish), ;
   */
/* END */
return(nil)

function HGR110_grid_1_OnAdd()
/* BEGIN */
   local aItem, nSeqno
   aItem := HGR110.grid_1.Item(HGR110.grid_1.ItemCount)
   nSeqno := aItem[8] + 1
   HGR110.grid_1.AddItem({"","","",2,2,"","",nSeqno,0})
   HGR110.grid_1.value := HGR110.grid_1.ItemCount
/* END */
/* BEGIN */
/* END */
return(nil)

function HGR110_grid_1_OnDelete()
/* BEGIN */
   if HGR110.grid_1.Value = 0
      MsgInfo("Please select a productchoice from the list first")
      return(nil)
   endif
   HGR110.grid_1.DeleteItem(HGR110.grid_1.Value)
/* END */
/* BEGIN */
/* END */
return(nil)

function HGR110_grid_1_OnUp()
/* BEGIN */
   local item := array(9), item1, item2, row, seqno1, seqno2
   if HGR110.grid_1.Value > 1
      row := HGR110.grid_1.Value
      item1 := HGR110.grid_1.Item(row - 1)
      item2 := HGR110.grid_1.Item(row)
      seqno1 := item1[8]
      seqno2 := item2[8]
      acopy(item1, item)
	   acopy(item2, item1)
      acopy(item, item2)
      item1[8] := seqno1
      item2[8] := seqno2
      HGR110.grid_1.Item(row - 1) := item1
      HGR110.grid_1.Item(row) := item2
      HGR110.grid_1.Value := row - 1
   endif
/* END */
/* BEGIN */
/* END */
return(nil)

function HGR110_grid_1_OnDown()
/* BEGIN */
   local item := array(9), row, seqno1, seqno2
   if HGR110.grid_1.Value < HGR110.grid_1.ItemCount
      row := HGR110.grid_1.Value
      item1 := HGR110.grid_1.Item(row)
      item2 := HGR110.grid_1.Item(row + 1)
      seqno1 := item1[8]
      seqno2 := item2[8]
      acopy(item2, item)
	   acopy(item1, item2)
      acopy(item, item1)
      item1[8] := seqno1
      item2[8] := seqno2
      HGR110.grid_1.Item(row) := item1
      HGR110.grid_1.Item(row + 1) := item2
      HGR110.grid_1.Value := row + 1
   endif   
/* END */
/* BEGIN */
/* END */
return(nil)

function HGR110_OnCancel()
/* BEGIN */
/* END */
   HGR110_OnInit()
/* BEGIN */
/* END */
return(nil)

function HGR110_OnApply()
/* BEGIN */
   local productChoices, p, n, m, aItem, pos, txdate := date(), txtime := time()
/* END */
/* BEGIN */
   productChoices := ProductChoices():Find(nApplid, {})
   for n := 1 to len(productChoices)
      p := productChoices[n]
      if p:deleted = "N"
         // lookup in items
         for m := 1 to HGR110.grid_1.ItemCount
            aItem := HGR110.grid_1.Item(m)
            if p:id = aItem[9]
               exit
            endif
         next      
         if m > HGR110.grid_1.ItemCount
            // delete
            p:deleted := "Y"
            p:Save(txdate, txtime, userprofile:userid, txdate)
         endif
      endif   
   next
   // add/update vanuit items
   for n := 1 to HGR110.grid_1.ItemCount
      // lookup in objectmodel
      aItem := HGR110.grid_1.Item(n)
      pos := ascan(productChoices, {|x|x:id = aItem[9]})
      if pos > 0
         p := productChoices[pos]
      else
         p := ProductChoice():New()
         p:application:id := application:id
      endif   
      p:nameTable := aItem[1]
      p:codeChoice := aItem[2]
      if language = 1
         p:descrChoice := aItem[3]
      else
         p:descrChoiceEnglish := aItem[3]
      endif   
      p:indicDefaultChoice := if(aItem[4] = 1, "Y", "N")
      p:indicCommercialDecision := if(aItem[5] = 1, "Y", "N")
      p:nameReferenceTable:= aItem[6]
      p:codeReferenceChoice := aItem[7]
      p:numberSequence := aItem[8]
      p:id := aItem[9]
      p:Save(txdate, txtime, userprofile:userid, txdate)
   next
   HGR110.Release
/* END */
return(nil)

function HGR110_OnClose()
/* BEGIN */
/* END */
return(.T.)

/* BEGIN */
/* END */
