/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Classes
   Method Init() constructor
   Method Find(applid, classes, refdat)
   Method Get(id, class, requestor, refdat)
   /* BEGIN */
   /* END */
endclass   

Method Init() class Classes
return self

Method Find(applid, classes, refdat) class Classes
   local old := select(), obj := {}
   select 0
   use clss index clssa 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(applid, 10)
      do while .not. eof() .and. clss->APPLID = applid
         aadd(classes, Class():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(applid, 10)
      do while .not. eof() .and. clss->APPLID = applid
         obj := SaveRec(obj)
         DbfLogRollback("CLSS", clss->ID, refdat)
         if clss->DELETED == "N" .and. clss->INGDAT <= refdat 
            aadd(classes, Class():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return classes
   
Method Get(id, class, requestor, refdat) class Classes
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use CLSS index CLSS
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("CLSS", clss->ID, refdat)
         class:Transfer()	
         RestRec(obj)
      else
         class:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "application"
         Applications():Get(clss->APPLID, class:application, "class", refdat)
      endif
      if requestor != "property"
         Properties():Find(id, class:properties, refdat)
         for n := 1 to len(class:properties)
            Properties():Get(class:properties[n]:id, class:properties[n], "class", refdat)
         next
      endif
      if requestor != "rule"
         Rules():Find(id, class:rules, refdat)
         for n := 1 to len(class:rules)
            Rules():Get(class:rules[n]:id, class:rules[n], "class", refdat)
         next
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return class

class Class
   data id
   data nameClass
   data nameCollectionClass
   data nameSuperClass
   data nameParent
   data nameDatabaseFile
   data application
   data properties
   data rules
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Class
   self:id := 0
   self:nameClass := ""
   self:nameCollectionClass := ""
   self:nameSuperClass := ""
   self:nameParent := ""
   self:nameDatabaseFile := ""
   self:application := Application():New()
   self:properties := {}
   self:rules := {}
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use clss index clss, clssa
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = classes():Get(id, class():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               clss->DELETED := self:deleted
               clss->USERID := userid
               clss->TXDATE := txdate
               clss->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("CLSS")
         self:id = newId
         AddRec(1)	
         clss->ID := self:id
         /* BEGIN */
         clss->APPLID := self:application:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Class
local retval := .T.
   set exact on
   if self:nameClass != old_rec:nameClass
      retval := .F.
   endif
   if self:nameCollectionClass != old_rec:nameCollectionClass
      retval := .F.
   endif
   if self:nameSuperClass != old_rec:nameSuperClass
      retval := .F.
   endif
   if self:nameParent != old_rec:nameParent
      retval := .F.
   endif
   if self:nameDatabaseFile != old_rec:nameDatabaseFile
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Class
   self:id := clss->ID 	
   self:nameClass := rtrim(clss->CLASSNAME)
   self:nameCollectionClass := rtrim(clss->COLLCLASS)
   self:nameSuperClass := rtrim(clss->SUPERCLASS)
   self:nameParent := rtrim(clss->PARENT)
   self:nameDatabaseFile := rtrim(clss->DBNAME)
   self:deleted := clss->DELETED 	
   self:userid := clss->USERID 	
   self:txdate := clss->TXDATE 	
   self:txtime := clss->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Class
   clss->CLASSNAME := self:nameClass
   clss->COLLCLASS := self:nameCollectionClass
   clss->SUPERCLASS := self:nameSuperClass
   clss->PARENT := self:nameParent
   clss->DBNAME := self:nameDatabaseFile
   clss->DELETED := self:deleted
   clss->USERID := userid
   clss->TXDATE := txdate
   clss->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Class
   if self:nameClass != old_rec:nameClass
      DbfLogAdd(alias(), "CLASSNAME", old_rec:id, old_rec:nameClass, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameCollectionClass != old_rec:nameCollectionClass
      DbfLogAdd(alias(), "COLLCLASS", old_rec:id, old_rec:nameCollectionClass, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameSuperClass != old_rec:nameSuperClass
      DbfLogAdd(alias(), "SUPERCLASS", old_rec:id, old_rec:nameSuperClass, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameParent != old_rec:nameParent
      DbfLogAdd(alias(), "PARENT", old_rec:id, old_rec:nameParent, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameDatabaseFile != old_rec:nameDatabaseFile
      DbfLogAdd(alias(), "DBNAME", old_rec:id, old_rec:nameDatabaseFile, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
/* END */
