/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Controls
   Method Init() constructor
   Method Find(formid, controls, refdat)
   Method Get(id, control, requestor, refdat)
   /* BEGIN */
   /* END */
endclass   

Method Init() class Controls
return self

Method Find(formid, controls, refdat) class Controls
   local old := select(), obj := {}
   select 0
   use ctrl index ctrla 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(formid, 10)
      do while .not. eof() .and. ctrl->FORMID = formid
         aadd(controls, Control():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(formid, 10)
      do while .not. eof() .and. ctrl->FORMID = formid
         obj := SaveRec(obj)
         DbfLogRollback("CTRL", ctrl->ID, refdat)
         if ctrl->DELETED == "N" .and. ctrl->INGDAT <= refdat 
            aadd(controls, Control():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return controls
   
Method Get(id, control, requestor, refdat) class Controls
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use CTRL index CTRL
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("CTRL", ctrl->ID, refdat)
         control:Transfer()	
         RestRec(obj)
      else
         control:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "form"
         Forms():Get(ctrl->FORMID, control:form, "control", refdat)
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return control

class Control
   data id
   data textLabel
   data textLabelEnglish
   data nameBaseObject
   data nameControl
   data textInitialValue
   data codeType
   data indicVisible
   data indicReadOnly
   data valueWidth
   data codeAlignment
   data textItems
   data indicOnChange
   data indicOnAction
   data valueAuthorisationLevel
   data numberSequence
   data form
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   Method IsNumeric()
   /* END */
endclass

Method Init() class Control
   self:id := 0
   self:textLabel := ""
   self:textLabelEnglish := ""
   self:nameBaseObject := ""
   self:nameControl := ""
   self:textInitialValue := ""
   self:codeType := ""
   self:indicVisible := ""
   self:indicReadOnly := ""
   self:valueWidth := 0
   self:codeAlignment := ""
   self:textItems := ""
   self:indicOnChange := ""
   self:indicOnAction := ""
   self:valueAuthorisationLevel := 0
   self:numberSequence := 0
   self:form := Form():New()
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use ctrl index ctrl, ctrla
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = controls():Get(id, control():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               ctrl->DELETED := self:deleted
               ctrl->USERID := userid
               ctrl->TXDATE := txdate
               ctrl->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   if self:codeType == "Column textbox" .and. self:valueWidth = 0
      aadd(aBrokenRules, "BR001")
   endif   
   if self:codeType == "Grid" .and. empty(self:nameBaseObject)
      aadd(aBrokenRules, "BR002")
   endif   
   if self:codeType == "Textbox" .and. !empty(self:nameBaseObject) 
      if self:IsNumeric() .and. empty(self:textInitialValue) 
         aadd(aBrokenRules, "BR003")
      endif   
   endif   
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("CTRL")
         self:id = newId
         AddRec(1)	
         ctrl->ID := self:id
         /* BEGIN */
         ctrl->FORMID := self:form:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Control
local retval := .T.
   set exact on
   if self:textLabel != old_rec:textLabel
      retval := .F.
   endif
   if self:textLabelEnglish != old_rec:textLabelEnglish
      retval := .F.
   endif
   if self:nameBaseObject != old_rec:nameBaseObject
      retval := .F.
   endif
   if self:nameControl != old_rec:nameControl
      retval := .F.
   endif
   if self:textInitialValue != old_rec:textInitialValue
      retval := .F.
   endif
   if self:codeType != old_rec:codeType
      retval := .F.
   endif
   if self:indicVisible != old_rec:indicVisible
      retval := .F.
   endif
   if self:indicReadOnly != old_rec:indicReadOnly
      retval := .F.
   endif
   if self:valueWidth != old_rec:valueWidth
      retval := .F.
   endif
   if self:codeAlignment != old_rec:codeAlignment
      retval := .F.
   endif
   if self:textItems != old_rec:textItems
      retval := .F.
   endif
   if self:indicOnChange != old_rec:indicOnChange
      retval := .F.
   endif
   if self:indicOnAction != old_rec:indicOnAction
      retval := .F.
   endif
   if self:valueAuthorisationLevel != old_rec:valueAuthorisationLevel
      retval := .F.
   endif
   if self:numberSequence != old_rec:numberSequence
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Control
   self:id := ctrl->ID 	
   self:textLabel := rtrim(ctrl->LABEL)
   self:textLabelEnglish := rtrim(ctrl->LABELUK)
   self:nameBaseObject := rtrim(ctrl->OBJECTNAME)
   self:nameControl := rtrim(ctrl->FIELDNAME)
   self:textInitialValue := rtrim(ctrl->INITVALUE)
   self:codeType := rtrim(ctrl->CTRLTYPE)
   self:indicVisible := rtrim(ctrl->VISIBLE)
   self:indicReadOnly := rtrim(ctrl->READONLY)
   self:valueWidth := ctrl->WIDTH
   self:codeAlignment := rtrim(ctrl->ALIGNMENT)
   self:textItems := rtrim(ctrl->ITEMS)
   self:indicOnChange := rtrim(ctrl->ONCHANGE)
   self:indicOnAction := rtrim(ctrl->ONACTION)
   self:valueAuthorisationLevel := ctrl->AUTHLEVEL
   self:numberSequence := ctrl->SEQNO
   self:deleted := ctrl->DELETED 	
   self:userid := ctrl->USERID 	
   self:txdate := ctrl->TXDATE 	
   self:txtime := ctrl->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Control
   ctrl->LABEL := self:textLabel
   ctrl->LABELUK := self:textLabelEnglish
   ctrl->OBJECTNAME := self:nameBaseObject
   ctrl->FIELDNAME := self:nameControl
   ctrl->INITVALUE := self:textInitialValue
   ctrl->CTRLTYPE := self:codeType
   ctrl->VISIBLE := self:indicVisible
   ctrl->READONLY := self:indicReadOnly
   ctrl->WIDTH := self:valueWidth
   ctrl->ALIGNMENT := self:codeAlignment
   ctrl->ITEMS := self:textItems
   ctrl->ONCHANGE := self:indicOnChange
   ctrl->ONACTION := self:indicOnAction
   ctrl->AUTHLEVEL := self:valueAuthorisationLevel
   ctrl->SEQNO := self:numberSequence
   ctrl->DELETED := self:deleted
   ctrl->USERID := userid
   ctrl->TXDATE := txdate
   ctrl->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Control
   if self:textLabel != old_rec:textLabel
      DbfLogAdd(alias(), "LABEL", old_rec:id, old_rec:textLabel, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:textLabelEnglish != old_rec:textLabelEnglish
      DbfLogAdd(alias(), "LABELUK", old_rec:id, old_rec:textLabelEnglish, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameBaseObject != old_rec:nameBaseObject
      DbfLogAdd(alias(), "OBJECTNAME", old_rec:id, old_rec:nameBaseObject, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameControl != old_rec:nameControl
      DbfLogAdd(alias(), "FIELDNAME", old_rec:id, old_rec:nameControl, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:textInitialValue != old_rec:textInitialValue
      DbfLogAdd(alias(), "INITVALUE", old_rec:id, old_rec:textInitialValue, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeType != old_rec:codeType
      DbfLogAdd(alias(), "CTRLTYPE", old_rec:id, old_rec:codeType, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indicVisible != old_rec:indicVisible
      DbfLogAdd(alias(), "VISIBLE", old_rec:id, old_rec:indicVisible, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indicReadOnly != old_rec:indicReadOnly
      DbfLogAdd(alias(), "READONLY", old_rec:id, old_rec:indicReadOnly, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:valueWidth != old_rec:valueWidth
      DbfLogAdd(alias(), "WIDTH", old_rec:id, str(old_rec:valueWidth), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeAlignment != old_rec:codeAlignment
      DbfLogAdd(alias(), "ALIGNMENT", old_rec:id, old_rec:codeAlignment, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:textItems != old_rec:textItems
      DbfLogAdd(alias(), "ITEMS", old_rec:id, old_rec:textItems, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indicOnChange != old_rec:indicOnChange
      DbfLogAdd(alias(), "ONCHANGE", old_rec:id, old_rec:indicOnChange, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indicOnAction != old_rec:indicOnAction
      DbfLogAdd(alias(), "ONACTION", old_rec:id, old_rec:indicOnAction, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:valueAuthorisationLevel != old_rec:valueAuthorisationLevel
      DbfLogAdd(alias(), "AUTHLEVEL", old_rec:id, str(old_rec:valueAuthorisationLevel), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberSequence != old_rec:numberSequence
      DbfLogAdd(alias(), "SEQNO", old_rec:id, str(old_rec:numberSequence), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method IsNumeric() class Control
   local bNumeric := .F., oProperty 
   oProperty := Properties():LookupProperty(self:nameBaseObject, self:nameControl) 
   if !empty(oProperty) .and. oProperty:codeType == "NUMERIC"
      bNumeric := .T.
   endif   
return(bNumeric)
/* END */
