/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Properties
   Method Init() constructor
   Method Find(clssid, properties, refdat)
   Method Get(id, property, requestor, refdat)
   /* BEGIN */
   Method LookupProperty(cNameClass, cNameControl)
   /* END */
endclass   

Method Init() class Properties
return self

Method Find(clssid, properties, refdat) class Properties
   local old := select(), obj := {}
   select 0
   use prop index propa 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(clssid, 10)
      do while .not. eof() .and. prop->CLSSID = clssid
         aadd(properties, Property():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(clssid, 10)
      do while .not. eof() .and. prop->CLSSID = clssid
         obj := SaveRec(obj)
         DbfLogRollback("PROP", prop->ID, refdat)
         if prop->DELETED == "N" .and. prop->INGDAT <= refdat 
            aadd(properties, Property():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return properties
   
Method Get(id, property, requestor, refdat) class Properties
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use PROP index PROP
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("PROP", prop->ID, refdat)
         property:Transfer()	
         RestRec(obj)
      else
         property:Transfer()	
      endif
   endif
   if requestor != "old" 
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return property

class Property
   data id
   data nameDatabaseFile
   data nameDatabaseField
   data nameProperty
   data codeType
   data valueLength
   data valueDecimals
   data codeMultiplicity
   data descrValidations
   data numberSequence
   data idClass
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Property
   self:id := 0
   self:nameDatabaseFile := ""
   self:nameDatabaseField := ""
   self:nameProperty := ""
   self:codeType := ""
   self:valueLength := 0
   self:valueDecimals := 0
   self:codeMultiplicity := ""
   self:descrValidations := ""
   self:numberSequence := 0
   self:idClass := 0
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use prop index prop, propa, propb
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = properties():Get(id, property():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               prop->DELETED := self:deleted
               prop->USERID := userid
               prop->TXDATE := txdate
               prop->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("PROP")
         self:id = newId
         AddRec(1)	
         prop->ID := self:id
         /* BEGIN */
      // MsgInfo("self:class:id=" + str(self:class:id)) levert self:id op (van property dus)
      prop->CLSSID := self:class:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Property
local retval := .T.
   set exact on
   if self:nameDatabaseFile != old_rec:nameDatabaseFile
      retval := .F.
   endif
   if self:nameDatabaseField != old_rec:nameDatabaseField
      retval := .F.
   endif
   if self:nameProperty != old_rec:nameProperty
      retval := .F.
   endif
   if self:codeType != old_rec:codeType
      retval := .F.
   endif
   if self:valueLength != old_rec:valueLength
      retval := .F.
   endif
   if self:valueDecimals != old_rec:valueDecimals
      retval := .F.
   endif
   if self:codeMultiplicity != old_rec:codeMultiplicity
      retval := .F.
   endif
   if self:descrValidations != old_rec:descrValidations
      retval := .F.
   endif
   if self:numberSequence != old_rec:numberSequence
      retval := .F.
   endif
   if self:idClass != old_rec:idClass
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Property
   self:id := prop->ID 	
   self:nameDatabaseFile := rtrim(prop->DBNAME)
   self:nameDatabaseField := rtrim(prop->NAME)
   self:nameProperty := rtrim(prop->DESCR)
   self:codeType := rtrim(prop->TYPE)
   self:valueLength := prop->LENGTH
   self:valueDecimals := prop->DEC
   self:codeMultiplicity := rtrim(prop->MULTIPL)
   self:descrValidations := rtrim(prop->VALRULES)
   self:numberSequence := prop->SEQNO
   self:idClass := prop->CLSSID
   self:deleted := prop->DELETED 	
   self:userid := prop->USERID 	
   self:txdate := prop->TXDATE 	
   self:txtime := prop->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Property
   prop->DBNAME := self:nameDatabaseFile
   prop->NAME := self:nameDatabaseField
   prop->DESCR := self:nameProperty
   prop->TYPE := self:codeType
   prop->LENGTH := self:valueLength
   prop->DEC := self:valueDecimals
   prop->MULTIPL := self:codeMultiplicity
   prop->VALRULES := self:descrValidations
   prop->SEQNO := self:numberSequence
   prop->CLSSID := self:idClass
   prop->DELETED := self:deleted
   prop->USERID := userid
   prop->TXDATE := txdate
   prop->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Property
   if self:nameDatabaseFile != old_rec:nameDatabaseFile
      DbfLogAdd(alias(), "DBNAME", old_rec:id, old_rec:nameDatabaseFile, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameDatabaseField != old_rec:nameDatabaseField
      DbfLogAdd(alias(), "NAME", old_rec:id, old_rec:nameDatabaseField, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameProperty != old_rec:nameProperty
      DbfLogAdd(alias(), "DESCR", old_rec:id, old_rec:nameProperty, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeType != old_rec:codeType
      DbfLogAdd(alias(), "TYPE", old_rec:id, old_rec:codeType, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:valueLength != old_rec:valueLength
      DbfLogAdd(alias(), "LENGTH", old_rec:id, str(old_rec:valueLength), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:valueDecimals != old_rec:valueDecimals
      DbfLogAdd(alias(), "DEC", old_rec:id, str(old_rec:valueDecimals), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeMultiplicity != old_rec:codeMultiplicity
      DbfLogAdd(alias(), "MULTIPL", old_rec:id, old_rec:codeMultiplicity, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrValidations != old_rec:descrValidations
      DbfLogAdd(alias(), "VALRULES", old_rec:id, old_rec:descrValidations, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberSequence != old_rec:numberSequence
      DbfLogAdd(alias(), "SEQNO", old_rec:id, str(old_rec:numberSequence), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:idClass != old_rec:idClass
      DbfLogAdd(alias(), "CLSSID", old_rec:id, str(old_rec:idClass), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
Method LookupProperty(cNameClass, cNameControl) class Properties
   local old := select(), oProperty := nil
   select 0
   use prop index propb
   seek str(GetClassId(cNameClass), 10)+cNameControl
   if found()
      oProperty := Property():New()
      oProperty:Transfer()      
   endif   
   use
   select(old)
return(oProperty)
/* END */
