/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class ProductChoices
   Method Init() constructor
   Method Find(applid, productChoices, refdat)
   Method Get(id, productChoice, requestor, refdat)
   /* BEGIN */
   /* END */
endclass   

Method Init() class ProductChoices
return self

Method Find(applid, productChoices, refdat) class ProductChoices
   local old := select(), obj := {}
   select 0
   use refc index refca 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(applid, 10)
      do while .not. eof() .and. refc->APPLID = applid
         aadd(productChoices, ProductChoice():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(applid, 10)
      do while .not. eof() .and. refc->APPLID = applid
         obj := SaveRec(obj)
         DbfLogRollback("REFC", refc->ID, refdat)
         if refc->DELETED == "N" .and. refc->INGDAT <= refdat 
            aadd(productChoices, ProductChoice():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return productChoices
   
Method Get(id, productChoice, requestor, refdat) class ProductChoices
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use REFC index REFC
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("REFC", refc->ID, refdat)
         productChoice:Transfer()	
         RestRec(obj)
      else
         productChoice:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "application"
         Applications():Get(refc->APPLID, productChoice:application, "productChoice", refdat)
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return productChoice

class ProductChoice
   data id
   data nameReferenceTable
   data codeReferenceChoice
   data nameTable
   data codeChoice
   data descrChoice
   data descrChoiceEnglish
   data indicCommercialDecision
   data indicDefaultChoice
   data numberSequence
   data application
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class ProductChoice
   self:id := 0
   self:nameReferenceTable := ""
   self:codeReferenceChoice := ""
   self:nameTable := ""
   self:codeChoice := ""
   self:descrChoice := ""
   self:descrChoiceEnglish := ""
   self:indicCommercialDecision := ""
   self:indicDefaultChoice := ""
   self:numberSequence := 0
   self:application := Application():New()
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use refc index refc, refca, refcb
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = productChoices():Get(id, productChoice():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               refc->DELETED := self:deleted
               refc->USERID := userid
               refc->TXDATE := txdate
               refc->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("REFC")
         self:id = newId
         AddRec(1)	
         refc->ID := self:id
         /* BEGIN */
         refc->APPLID := self:application:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class ProductChoice
local retval := .T.
   set exact on
   if self:nameReferenceTable != old_rec:nameReferenceTable
      retval := .F.
   endif
   if self:codeReferenceChoice != old_rec:codeReferenceChoice
      retval := .F.
   endif
   if self:nameTable != old_rec:nameTable
      retval := .F.
   endif
   if self:codeChoice != old_rec:codeChoice
      retval := .F.
   endif
   if self:descrChoice != old_rec:descrChoice
      retval := .F.
   endif
   if self:descrChoiceEnglish != old_rec:descrChoiceEnglish
      retval := .F.
   endif
   if self:indicCommercialDecision != old_rec:indicCommercialDecision
      retval := .F.
   endif
   if self:indicDefaultChoice != old_rec:indicDefaultChoice
      retval := .F.
   endif
   if self:numberSequence != old_rec:numberSequence
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class ProductChoice
   self:id := refc->ID 	
   self:nameReferenceTable := rtrim(refc->REFTABEL)
   self:codeReferenceChoice := rtrim(refc->REF)
   self:nameTable := rtrim(refc->TABEL)
   self:codeChoice := rtrim(refc->CODE)
   self:descrChoice := rtrim(refc->OMS)
   self:descrChoiceEnglish := rtrim(refc->OMSUK)
   self:indicCommercialDecision := rtrim(refc->CB)
   self:indicDefaultChoice := rtrim(refc->DEFAULT)
   self:numberSequence := refc->SEQNO
   self:deleted := refc->DELETED 	
   self:userid := refc->USERID 	
   self:txdate := refc->TXDATE 	
   self:txtime := refc->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class ProductChoice
   refc->REFTABEL := self:nameReferenceTable
   refc->REF := self:codeReferenceChoice
   refc->TABEL := self:nameTable
   refc->CODE := self:codeChoice
   refc->OMS := self:descrChoice
   refc->OMSUK := self:descrChoiceEnglish
   refc->CB := self:indicCommercialDecision
   refc->DEFAULT := self:indicDefaultChoice
   refc->SEQNO := self:numberSequence
   refc->DELETED := self:deleted
   refc->USERID := userid
   refc->TXDATE := txdate
   refc->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class ProductChoice
   if self:nameReferenceTable != old_rec:nameReferenceTable
      DbfLogAdd(alias(), "REFTABEL", old_rec:id, old_rec:nameReferenceTable, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeReferenceChoice != old_rec:codeReferenceChoice
      DbfLogAdd(alias(), "REF", old_rec:id, old_rec:codeReferenceChoice, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameTable != old_rec:nameTable
      DbfLogAdd(alias(), "TABEL", old_rec:id, old_rec:nameTable, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:codeChoice != old_rec:codeChoice
      DbfLogAdd(alias(), "CODE", old_rec:id, old_rec:codeChoice, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrChoice != old_rec:descrChoice
      DbfLogAdd(alias(), "OMS", old_rec:id, old_rec:descrChoice, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:descrChoiceEnglish != old_rec:descrChoiceEnglish
      DbfLogAdd(alias(), "OMSUK", old_rec:id, old_rec:descrChoiceEnglish, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indicCommercialDecision != old_rec:indicCommercialDecision
      DbfLogAdd(alias(), "CB", old_rec:id, old_rec:indicCommercialDecision, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:indicDefaultChoice != old_rec:indicDefaultChoice
      DbfLogAdd(alias(), "DEFAULT", old_rec:id, old_rec:indicDefaultChoice, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:numberSequence != old_rec:numberSequence
      DbfLogAdd(alias(), "SEQNO", old_rec:id, str(old_rec:numberSequence), old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
/* END */
