#include <hmg.ch>

#define WINROW      100
#define WINCOL      120
#define WINWIDTH    770
#define WINHEIGHT   550

#define DefFrames             frames
#define DefFrameLabel         frames[n, 1] 
#define DefFrameLabelUK       frames[n, 2] 
#define DefFrameVisible       frames[n, 3] 
#define DefFrameControls      frames[n, 4] 

#define DefFrameControl      	frames[n, 4, m] 
#define DefCtrlType       	   frames[n, 4, m,  1] 
#define DefCtrlLabel		      frames[n, 4, m,  2] 
#define DefCtrlLabelUK		   frames[n, 4, m,  3] 
#define DefCtrlObjectName	   frames[n, 4, m,  4] 
#define DefCtrlFieldName	   frames[n, 4, m,  5] 
#define DefCtrlInitValue	   frames[n, 4, m,  6] 
#define DefCtrlVisible	      frames[n, 4, m,  7] 
#define DefCtrlReadOnly 	   frames[n, 4, m,  8] 
#define DefCtrlWidth    	   frames[n, 4, m,  9] 
#define DefCtrlAlignment	   frames[n, 4, m, 10] 
#define DefCtrlItems    	   frames[n, 4, m, 11] 
#define DefCtrlOnChange 	   frames[n, 4, m, 12] 
#define DefCtrlOnAction		   frames[n, 4, m, 13] 
#define DefCtrlAuthLevel	   frames[n, 4, m, 14] 
#define DefCtrlFieldId  	   frames[n, 4, m, 15] 

#define DefGrids		         grids
#define DefGridName       	   grids[n, 1] 
#define DefGridLabel       	grids[n, 2] 
#define DefGridLabelUK       	grids[n, 3] 
#define DefGridControls      	grids[n, 4] 
#define DefGridButtons      	grids[n, 5]
#define DefGridReadOnly      	grids[n, 6]

#define DefGridControl      	grids[n, 4, m] 
#define DefGridCtrlType      	grids[n, 4, m,  1] 
#define DefGridCtrlLabel		grids[n, 4, m,  2] 
#define DefGridCtrlLabelUK		grids[n, 4, m,  3] 
#define DefGridCtrlObjectName	grids[n, 4, m,  4] 
#define DefGridCtrlFieldName	grids[n, 4, m,  5] 
#define DefGridCtrlInitValue	grids[n, 4, m,  6] 
#define DefGridCtrlVisible	   grids[n, 4, m,  7] 
#define DefGridCtrlReadOnly 	grids[n, 4, m,  8] 
#define DefGridCtrlWidth   	grids[n, 4, m,  9] 
#define DefGridCtrlAlignment	grids[n, 4, m, 10] 
#define DefGridCtrlItems    	grids[n, 4, m, 11] 
#define DefGridCtrlOnChange 	grids[n, 4, m, 12] 
#define DefGridCtrlOnAction	grids[n, 4, m, 13] 
#define DefGridCtrlAuthLevel	grids[n, 4, m, 14] 
#define DefGridCtrlFieldId  	grids[n, 4, m, 15] 

#define DefGridButton      	grids[n, 5, m] 
#define DefButtonType       	grids[n, 5, m,  1] 
#define DefButtonLabel		   grids[n, 5, m,  2] 
#define DefButtonLabelUK      grids[n, 5, m,  3] 
#define DefButtonObjectName	grids[n, 5, m,  4] 
#define DefButtonFieldName	   grids[n, 5, m,  5] 
#define DefButtonInitValue	   grids[n, 5, m,  6] 
#define DefButtonVisible	   grids[n, 5, m,  7] 
#define DefButtonReadOnly 	   grids[n, 5, m,  8] 
#define DefButtonWidth  	   grids[n, 5, m,  9] 
#define DefButtonAlignment	   grids[n, 5, m, 10] 
#define DefButtonItems    	   grids[n, 5, m, 11] 
#define DefButtonOnChange 	   grids[n, 5, m, 12] 
#define DefButtonOnAction		grids[n, 5, m, 13] 
#define DefButtonAuthLevel	   grids[n, 5, m, 14] 
#define DefButtonFieldId  	   grids[n, 5, m, 15] 

declare window HGA210

Function HGA210_OnInit()
   select 0
   use form index forma
   do while .not. eof()
      if form->APPLID = nApplid
         HGA210.grid_1.AddItem({0, FORMCODE, if(language = 1, TITLE, TITLEUK), ID})
      endif   
      skip
   enddo
   use
Return nil

Function HGA210_OnChange()
   /* let erop dat item reserved word is ! */
   item1 := HGA210.grid_1.Item(HGA210.grid_1.Value)
   if item1[1] = 0
      item1[1] := 1
   else
      item1[1] := 0
   endif
   /* terugzetten blijkbaar nodig */   
   HGA210.grid_1.Item(HGA210.grid_1.Value) := item1
Return Nil

Function HGA210_OnGenerate()
   local n
   for n := 1 to HGA210.grid_1.ItemCount
      item := HGA210.grid_1.Item(n)
      if item[1] = 1
         GenerateForm(item[4])
         GenerateDlg(item[4])
      endif 
   next
   HGA210.Hide
   HGA210.Release
Return nil

Function GenerateForm(id)
   local winname, printfile, dbname, formid, classid, classname, n, m, row, col, row_old, ar, grids, ;
   bTextbox := .F., nr, frames, buttons_bottom_left, buttons_bottom_right_1, buttons_bottom_right_2, ;
   width, height, counter, s
   select 0
   use form index form
   formid := id
   seek str(formid, 10)
   winname := form->FORMCODE
   printfile := fcreate(winname + ".fmg")
   dbname := GetDbName(rtrim(form->baseobject))
   classid := GetClassId(rtrim(form->baseobject))
   classname := form->baseobject
   // schrijf definitie
   write_window_definition(printfile)
   nr := 1
   row := 20
   col := 20
   frames := {}	
   grids := {}
	buttons_bottom_left := {}	
	buttons_bottom_right_1 := {}	
	buttons_bottom_right_2 := {}	
   select 0
   use ctrl index ctrla
   seek str(id, 10)
   do while .not. eof() .and. ctrl->FORMID = id
      do case
      case rtrim(ctrl->CTRLTYPE) == "Frame"
         aadd(frames, {ctrl->LABEL, ctrl->LABELUK, ctrl->VISIBLE, {}})
      case rtrim(ctrl->CTRLTYPE) == "Textbox" .or. rtrim(ctrl->CTRLTYPE) == "Combobox" ;
         .or. rtrim(ctrl->CTRLTYPE) == "Checkbox" .or. rtrim(ctrl->CTRLTYPE) == "Datepicker"
         if len(frames) > 0
            aadd(frames[len(frames), 4], {ctrl->CTRLTYPE, ctrl->LABEL, ctrl->LABELUK, ctrl->OBJECTNAME, ctrl->FIELDNAME, ;
            ctrl->INITVALUE, ctrl->VISIBLE, ctrl->READONLY, ctrl->WIDTH, ctrl->ALIGNMENT, ctrl->ITEMS, ;
            ctrl->ONCHANGE, ctrl->ONACTION, ctrl->AUTHLEVEL, ctrl->SEQNO})
         else
            aadd(frames, {"dummy", "dummy", "Y", {}})
            aadd(frames[len(frames), 4], {ctrl->CTRLTYPE, ctrl->LABEL, ctrl->LABELUK, ctrl->OBJECTNAME, ctrl->FIELDNAME, ;
            ctrl->INITVALUE, ctrl->VISIBLE, ctrl->READONLY, ctrl->WIDTH, ctrl->ALIGNMENT, ctrl->ITEMS, ;
            ctrl->ONCHANGE, ctrl->ONACTION, ctrl->AUTHLEVEL, ctrl->SEQNO})
         endif
      case rtrim(ctrl->CTRLTYPE) == "Grid"
		  	aadd(grids, {rtrim(ctrl->FIELDNAME), rtrim(ctrl->LABEL), ctrl->LABELUK, {}, {}, ctrl->READONLY})
      case rtrim(ctrl->CTRLTYPE) == "Column textbox" .or. rtrim(ctrl->CTRLTYPE) == "Column combobox" ;
         .or. rtrim(ctrl->CTRLTYPE) == "Column datepicker"
            if len(grids) > 0
               aadd(grids[len(grids), 4], {ctrl->CTRLTYPE, ctrl->LABEL, ctrl->LABELUK, ctrl->OBJECTNAME, ctrl->FIELDNAME, ;
               ctrl->INITVALUE, ctrl->VISIBLE, ctrl->READONLY, ctrl->WIDTH, ctrl->ALIGNMENT, ctrl->ITEMS, ;
               ctrl->ONCHANGE, ctrl->ONACTION, ctrl->AUTHLEVEL, ctrl->SEQNO})
            else   
               aadd(grids, {"dummy", "", "", {}, {}, ctrl->READONLY})
               aadd(grids[len(grids), 4], {ctrl->CTRLTYPE, ctrl->LABEL, ctrl->LABELUK, ctrl->OBJECTNAME, ctrl->FIELDNAME, ;
               ctrl->INITVALUE, ctrl->VISIBLE, ctrl->READONLY, ctrl->WIDTH, ctrl->ALIGNMENT, ctrl->ITEMS, ;
               ctrl->ONCHANGE, ctrl->ONACTION, ctrl->AUTHLEVEL, ctrl->SEQNO})
            endif   
      case rtrim(ctrl->CTRLTYPE) == "Button"
         if rtrim(ctrl->ALIGNMENT) = "Left" .or. rtrim(ctrl->ALIGNMENT) = "Right" 
            if len(grids) > 0
               aadd(grids[len(grids), 5], {ctrl->CTRLTYPE, ctrl->LABEL, ctrl->LABELUK, ctrl->OBJECTNAME, ctrl->FIELDNAME, ;
               ctrl->INITVALUE, ctrl->VISIBLE, ctrl->READONLY, ctrl->WIDTH, ctrl->ALIGNMENT, ctrl->ITEMS, ;
               ctrl->ONCHANGE, ctrl->ONACTION, ctrl->AUTHLEVEL, ctrl->SEQNO})
            else   
			   aadd(grids, {"dummy", "", "", {}, {}, ctrl->READONLY})
               aadd(grids[len(grids), 5], {ctrl->CTRLTYPE, ctrl->LABEL, ctrl->LABELUK, ctrl->OBJECTNAME, ctrl->FIELDNAME, ;
               ctrl->INITVALUE, ctrl->VISIBLE, ctrl->READONLY, ctrl->WIDTH, ctrl->ALIGNMENT, ctrl->ITEMS, ;
               ctrl->ONCHANGE, ctrl->ONACTION, ctrl->AUTHLEVEL, ctrl->SEQNO})
            endif   
         elseif rtrim(ctrl->ALIGNMENT) = "Bottom left"    
            aadd(buttons_bottom_left, {ctrl->CTRLTYPE, ctrl->LABEL, ctrl->LABELUK, ctrl->OBJECTNAME, ctrl->FIELDNAME, ;
            ctrl->INITVALUE, ctrl->VISIBLE, ctrl->READONLY, ctrl->WIDTH, ctrl->ALIGNMENT, ctrl->ITEMS, ;
            ctrl->ONCHANGE, ctrl->ONACTION, ctrl->AUTHLEVEL, ctrl->SEQNO})
         else
            if ctrl->VISIBLE = "Y"
               aadd(buttons_bottom_right_1, {ctrl->CTRLTYPE, ctrl->LABEL, ctrl->LABELUK, ctrl->OBJECTNAME, ctrl->FIELDNAME, ;
               ctrl->INITVALUE, ctrl->VISIBLE, ctrl->READONLY, ctrl->WIDTH, ctrl->ALIGNMENT, ctrl->ITEMS, ;
               ctrl->ONCHANGE, ctrl->ONACTION, ctrl->AUTHLEVEL, ctrl->SEQNO})
            else   
               aadd(buttons_bottom_right_2, {ctrl->CTRLTYPE, ctrl->LABEL, ctrl->LABELUK, ctrl->OBJECTNAME, ctrl->FIELDNAME, ;
               ctrl->INITVALUE, ctrl->VISIBLE, ctrl->READONLY, ctrl->WIDTH, ctrl->ALIGNMENT, ctrl->ITEMS, ;
               ctrl->ONCHANGE, ctrl->ONACTION, ctrl->AUTHLEVEL, ctrl->SEQNO})
            endif   
         endif   
      endcase   
      skip
   enddo
   use
   select("form")
   use

	row := row_old := 10
	col := 20
	for n := 1 to len(frames)
      counter := 0
      if n = 1
         row += 20
      endif
		for m := 1 to len(DefFrameControls)
	      // write label 
         if DefCtrlVisible = "Y"
            write_label(printfile, DefCtrlLabel, DefCtrlLabelUK, ((n-1)*10)+m, row+10, col)   
         endif   
         // write entryfield
         write_field(printfile, frames, n, m, row, col+300, winname, classid, classname)
         if DefCtrlVisible = "Y"
         	row += 30
         	counter++
         endif   
		next
		if DefFrameVisible = "Y" 
			width := WINWIDTH - 30
			height := counter * 30 + 30
	      write_frame(printfile, frames, n, row_old, col-10, width, height)
			row += 30
         row_old := row - 20
		endif
   next
   if row > 10
      row -= 20
   endif   
	for n := 1 to len(grids)
		// space for bottom buttons is 50
      if n = 1
         height := int((WINHEIGHT - 80 - row) / len(grids))
         if len(grids) > 1
            height -= 10
         endif   
		endif 
      width := WINWIDTH - 30 
	 	write_grid(printfile, grids, n, row, col-10, width, height)
      col := 20
		for m := 1 to len(DefGridButtons)
         write_button_grid(printfile, grids, n, m, row + height - 38, col, 100, 28, winname)
         col += 110   
		next
		row += height
		row += 10
      col := 20
	next	
   row := WINHEIGHT - 100
   col := 10
	for n := 1 to len(buttons_bottom_left)
      row := WINHEIGHT - 70
      write_button_bottom(printfile, buttons_bottom_left[n], row, col, 100, 28, winname)
      col += 110
	next
   /* write visible buttons */
   col := WINWIDTH - (len(buttons_bottom_right_1) * 110) - 10
	for n := 1 to len(buttons_bottom_right_1)
      row := WINHEIGHT - 70
     	write_button_bottom(printfile, buttons_bottom_right_1[n], row, col, 100, 28, winname)
      col += 110
	next
   /* write invisible buttons */
   col := WINWIDTH - (len(buttons_bottom_right_2) * 110) - 10
	for n := 1 to len(buttons_bottom_right_2)
      row := WINHEIGHT - 70
     	write_button_bottom(printfile, buttons_bottom_right_2[n], row, col, 100, 28, winname)
      col += 110
	next

   // write end definition
   s := 'end window'
   fwrite(printfile, s + chr(13) + chr(10))
   fclose(printfile)
return(nil)

function write_window_definition(printfile)
local s   
   s := 'define window template'
   fwrite(printfile, s)
   s := ' at '
   s += ltrim(str(WINROW))
   s += ', '
   s += ltrim(str(WINCOL)) 
   fwrite(printfile, s)
   s := ' width '
   s += ltrim(str(WINWIDTH))
   fwrite(printfile, s)
   s := ' height '
   s += ltrim(str(WINHEIGHT))
   fwrite(printfile, s)
   s := ' title "'
   s += form->FORMCODE
   s += ' '
   s += if(language = 1, rtrim(form->TITLE), rtrim(form->TITLEUK)) 
   s += '"'
   fwrite(printfile, s)
   s := ' on init '
   s += form->FORMCODE 
   s += '_OnInit()'
   fwrite(printfile, s)
   s := ' on interactiveclose '
   s += form->FORMCODE 
   s += '_OnClose()'
   fwrite(printfile, s + chr(13) + chr(10))
return(nil)

function write_label(printfile, label, labeluk, n, row, col)
local s 
   s := '    define label label_'
   s += ltrim(str(n))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        row '
   s += ltrim(str(row))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        col '
   s += ltrim(str(col))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        width 290'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        height 24'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        value "'
   if language = 1
      s += rtrim(label)
   else
      s += rtrim(labeluk)
   endif   
   s += '"'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '    end label'
   fwrite(printfile, s + chr(13) + chr(10))
return(nil)

function write_field(printfile, frames, n, m, row, col, winname, classid, classname)
local old := select(), id, bRefcFound
private ps
   // lookup refc
   bRefcFound := .F.
   select 0
   use refc index refc, refcb
   // index applid + tabel + code
   set order to 2
   seek str(nApplid, 10) + padr(DefCtrlFieldName, 10)
   if found()
      bRefcFound := .T.
   endif
   use
   select 0
   use prop index propb
   id := classid
   if rtrim(DefCtrlObjectName) != rtrim(classname)
      id := GetClassId(rtrim(DefCtrlObjectName))
   endif
   // index clssid+name
   seek str(id, 10)+padr(DefCtrlFieldName, 10)
   if found()
      do case
         case bRefcFound
            do case
               case prop->descr = "code"     
                  write_combobox(printfile, frames, n, m, row, col, {}, winname)
               case prop->descr = "indic"
                  write_combobox(printfile, frames, n, m, row, col, {}, winname)
               otherwise
                  write_combobox(printfile, frames, n, m, row, col, {}, winname)
            endcase  
         case prop->descr = "indic"
            if language = 1
               write_combobox(printfile, frames, n, m, row, col, {"Ja", "Nee"}, winname)
            else
               write_combobox(printfile, frames, n, m, row, col, {"Yes", "No"}, winname)
            endif   
         case prop->descr = "code" .and. rtrim(DefCtrlType) == "Textbox"
            write_textbox(printfile, frames, n, m, row, col, winname)
         case prop->descr = "code" .and. rtrim(DefCtrlType) == "Combobox"
            ps := rtrim(DefCtrlItems)
            if empty(ps)
               write_combobox(printfile, frames, n, m, row, col, "", winname)
            else
               write_combobox(printfile, frames, n, m, row, col, &ps., winname)
            endif
         case prop->descr = "aantal"       
            write_textbox(printfile, frames, n, m, row, col, winname)
         case prop->descr = "nummer" .or. prop->descr = "number"    
            write_textbox(printfile, frames, n, m, row, col, winname)
         case prop->descr = "id"     
            write_textbox(printfile, frames, n, m, row, col, winname)
         case prop->descr = "bedrag" .or. prop->descr = "value"      
            write_textbox(printfile, frames, n, m, row, col, winname)
         case prop->descr = "perc"     
            write_textbox(printfile, frames, n, m, row, col, winname)
         case prop->descr = "datum" .or. prop->descr = "date"     
            write_datepicker(printfile, frames, n, m, row, col, winname)
         otherwise
            write_textbox(printfile, frames, n, m, row, col, winname)
      endcase
   else
      do case
         case rtrim(DefCtrlType) == "Textbox"
            /* e.g. searchfield */
            write_textbox(printfile, frames, n, m, row, col, winname, "not objectbound")
         case rtrim(DefCtrlType) == "Combobox"
            /* e.g. descriptionNextActivity */
            ps := rtrim(DefCtrlItems)
            if empty(ps)
               write_combobox(printfile, frames, n, m, row, col, "", winname)
            else   
               write_combobox(printfile, frames, n, m, row, col, &ps., winname)
            endif   
         case rtrim(DefCtrlType) == "Datepicker"
            /* e.g. startdate change */
            write_datepicker(printfile, frames, n, m, row, col, winname)
      endcase         
   endif
   use
   select(old)
return(nil)

function write_combobox(printfile, frames, n, m, row, col, items, winname)
local s, i, old
   s := '    define combobox '
   s += rtrim(DefCtrlFieldName)
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        row '
   s += ltrim(str(row))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        col '
   s += ltrim(str(col))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        width 250'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        height 100'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        items '
   if empty(items)
      s += '{}'
   else
      s += '{'
      for i := 1 to len(items)
           if i > 1
              s  += ','
           endif   
           s += '"'
           s += items[i]
           s += '"'
      next 
      s += '}'
   endif
   fwrite(printfile, s + chr(13) + chr(10))
   if DefCtrlReadOnly = "Y"
      s := '        readonly .T.'
      fwrite(printfile, s + chr(13) + chr(10))
      s := '        tabstop .F.'
      fwrite(printfile, s + chr(13) + chr(10))
   endif
   if DefCtrlOnChange = "Y"
      s := '        onchange '
      s +=  winname
      s += '_'
      s += rtrim(DefCtrlFieldName)
      s += '_OnChange()'
      fwrite(printfile, s + chr(13) + chr(10))
   endif   
   s := '    end combobox'
   fwrite(printfile, s + chr(13) + chr(10))
return(nil)

function write_datepicker(printfile, frames, n, m, row, col, winname)
local s
   s := '    define datepicker '
   s += rtrim(DefCtrlFieldName)
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        row '
   s += ltrim(str(row))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        col '
   s += ltrim(str(col))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        width 120'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        height 24'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        value ctod("  -  -    ")'
   fwrite(printfile, s + chr(13) + chr(10))
   if DefCtrlReadOnly = "Y"
      s := '        readonly .T.'
      fwrite(printfile, s + chr(13) + chr(10))
      s := '        tabstop .F.'
      fwrite(printfile, s + chr(13) + chr(10))
   endif
   if DefCtrlOnChange = "Y"
      s := '        onchange '
      s +=  winname
      s += '_'
      s += rtrim(DefCtrlFieldName)
      s += '_OnChange()'
      fwrite(printfile, s + chr(13) + chr(10))
   endif   
   s := '    end datepicker'
   fwrite(printfile, s + chr(13) + chr(10))
return(nil)

function write_textbox(printfile, frames, n, m, row, col, winname, cNotObjectbound)
local s, len, width, i
   s := '    define textbox '
   s += rtrim(DefCtrlFieldName)
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        row '
   s += ltrim(str(row))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        col '
   s += ltrim(str(col))
   fwrite(printfile, s + chr(13) + chr(10))
   if pcount() < 8
      if prop->LENGTH >= 50
         width := 300
      elseif prop->LENGTH >= 30
         width := 200
      elseif prop->LENGTH >= 10
         width := 120
      else
         width := 60
      endif
   else
      width := DefCtrlWidth
   endif      
   s := '        width '
   s += ltrim(str(width))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        height 24'
   fwrite(printfile, s + chr(13) + chr(10))
   if pcount() < 8
      if rtrim(prop->TYPE) = 'CHARACTER'
         s := '        maxlength '
         s += ltrim(str(prop->LENGTH))
         fwrite(printfile, s + chr(13) + chr(10))
      elseif rtrim(prop->TYPE) = 'NUMERIC'
         s := '        format "E"'
         fwrite(printfile, s + chr(13) + chr(10))
         s := '        inputmask "'
         len := prop->LENGTH - prop->DEC
         for i := 1 to len
            s += "9"
         next
         if prop->DEC > 0
            s += "."
            for i := 1 to prop->DEC
               s += "9"
            next      
         endif
         s += '"'
         fwrite(printfile, s + chr(13) + chr(10))
         s := '        numeric .T.'
         fwrite(printfile, s + chr(13) + chr(10))
      endif
   else
      do case
         case right(rtrim(DefCtrlFieldName), 2) == "ID"
            if rtrim(DefCtrlFieldName) == "USERID"
            else
               s := '        format "E"'
               fwrite(printfile, s + chr(13) + chr(10))
               s := '        inputmask "9999999999"'
               fwrite(printfile, s + chr(13) + chr(10))
               s := '        numeric .T.'
               fwrite(printfile, s + chr(13) + chr(10))
            endif   
         case rtrim(DefCtrlFieldName) == "SEQNO" 
            s := '        format "E"'
            fwrite(printfile, s + chr(13) + chr(10))
            s := '        inputmask "99"'
            fwrite(printfile, s + chr(13) + chr(10))
            s := '        numeric .T.'
            fwrite(printfile, s + chr(13) + chr(10))
         case IsNumeric(rtrim(DefCtrlInitValue)) 
            s := '        format "E"'
            fwrite(printfile, s + chr(13) + chr(10))
            s := '        inputmask "' + GetNumericMask(rtrim(DefCtrlInitValue)) + '"'
            fwrite(printfile, s + chr(13) + chr(10))
            s := '        numeric .T.'
            fwrite(printfile, s + chr(13) + chr(10))
      endcase
   endif   
   if DefCtrlVisible = "N"
      s := '        visible .F.'
      fwrite(printfile, s + chr(13) + chr(10))
   endif
   if DefCtrlReadOnly = "Y"
      s := '        readonly .T.'
      fwrite(printfile, s + chr(13) + chr(10))
      s := '        tabstop .F.'
      fwrite(printfile, s + chr(13) + chr(10))
   endif
   if DefCtrlOnChange = "Y"
      s := '        onchange '
      s +=  winname
      s += '_'
      s += rtrim(DefCtrlFieldName)
      s += '_OnChange()'
      fwrite(printfile, s + chr(13) + chr(10))
   endif   
   s := '    end textbox'
   fwrite(printfile, s + chr(13) + chr(10))
return(nil)

function write_frame(printfile, frames, n, row, col, width, height)
local s
   s := '    define frame frame_'
   s += ltrim(str(n))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        row '
   s += ltrim(str(row))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        col '
   s += ltrim(str(col))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        width '
   s += ltrim(str(width))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        height '
   s += ltrim(str(height))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        caption "'
   if language = 1
      s += rtrim(DefFrameLabel)
   else
      s += rtrim(DefFrameLabelUK)
   endif
   s += '"'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '    end frame'
   fwrite(printfile, s + chr(13) + chr(10))
return(nil)

function write_button_grid(printfile, grids, n, m, row, col, width, height, winname)
local s
   s := '    define button '
   s += DefButtonFieldName
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        row '
   s += ltrim(str(row))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        col '
   s += ltrim(str(col))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        width 100'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        height 28'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        caption "&'
   if language = 1
      s += rtrim(DefButtonLabel)
   else
      s += rtrim(DefButtonLabelUK)
   endif   
   s += '"'
   fwrite(printfile, s + chr(13) + chr(10))
   if DefButtonOnAction = "Y"
      s := '        action '
      s += winname
      s += '_'
      s += rtrim(DefGridName)
      s += '_On'
      s += rtrim(DefButtonFieldName)
      s += '()'
      fwrite(printfile, s + chr(13) + chr(10))
   endif   
   s := '    end button'
   fwrite(printfile, s + chr(13) + chr(10))
return(nil)

function write_button_bottom(printfile, button, row, col, width, height, winname)
local s
   s := '    define button '
   s += rtrim(button[5])
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        row '
   s += ltrim(str(row))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        col '
   s += ltrim(str(col))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        width '
   s += ltrim(str(width))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        height '
   s += ltrim(str(height))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        caption "&'
   if language = 1
      s += rtrim(button[2])
   else
      s += rtrim(button[3])
   endif   
   s += '"'
   fwrite(printfile, s + chr(13) + chr(10))
   do case
      case rtrim(button[5]) == "Cancel"
         s := '        picture "br_no.bmp"'
         fwrite(printfile, s + chr(13) + chr(10))
         s := '        pictalignment left'
         fwrite(printfile, s + chr(13) + chr(10))
      case rtrim(button[5]) == "Apply"
         s := '        picture "br_ok.bmp"'
         fwrite(printfile, s + chr(13) + chr(10))
         s := '        pictalignment left'
         fwrite(printfile, s + chr(13) + chr(10))
      case rtrim(button[5]) == "Ok"
         s := '        picture "br_ok.bmp"'
         fwrite(printfile, s + chr(13) + chr(10))
         s := '        pictalignment left'
         fwrite(printfile, s + chr(13) + chr(10))
   endcase
   // here don't use define
   if button[7] = "N"
      s := '        visible .F.'
      fwrite(printfile, s + chr(13) + chr(10))
   endif   
   if button[13] = "Y"
      s := '        action '
      s += winname
     	if rtrim(button[10]) != "Left" .and. rtrim(button[5]) == "Update"
         	s += '_'
            s += lower(rtrim(button[5]))
      endif   
      s += '_On'
      s += rtrim(button[5])
      s += '()'
      fwrite(printfile, s + chr(13) + chr(10))
   endif   
   s := '    end button'
   fwrite(printfile, s + chr(13) + chr(10))
return(nil)

function write_grid(printfile, grids, n, row, col, width, height)
local s, s1, s2, s3
   if len(DefGridButtons) > 0
      // show grid within frame
      s := '    define frame frame_grid_'
      s += ltrim(str(n))
      fwrite(printfile, s + chr(13) + chr(10))
      s := '        row '
      s += ltrim(str(row))
      fwrite(printfile, s + chr(13) + chr(10))
      s := '        col '
      s += ltrim(str(col))
      fwrite(printfile, s + chr(13) + chr(10))
      s := '        width '
      s += ltrim(str(width))
      fwrite(printfile, s + chr(13) + chr(10))
      s := '        height '
      s += ltrim(str(height))
      fwrite(printfile, s + chr(13) + chr(10))
      s := '        caption "'
      if language = 1
         s += rtrim(DefGridLabel)
      else
         s += rtrim(DefGridLabelUK)
      endif   
      s += '"'
      fwrite(printfile, s + chr(13) + chr(10))
      s := '    end frame'
      fwrite(printfile, s + chr(13) + chr(10))
 
      row += 20
      col += 10
      width -= 20
      height -= 70
   else
      row += 10
      height -= 10
   endif   
   s := '    define grid '
   s += DefGridName
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        row '
   s += ltrim(str(row))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        col '
   s += ltrim(str(col))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        width '
   s += ltrim(str(width))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        height '
   s += ltrim(str(height))
   fwrite(printfile, s + chr(13) + chr(10))
   s := '        items {}'
   fwrite(printfile, s + chr(13) + chr(10))
   s1 := '        widths {'
   s2 := '        headers {' 
   s3 := '        columncontrols {'
   for m := 1 to len(DefGridControls)
      if m > 1
         s1 += ','
         s2 += ','
         s3 += ','
      endif
      s1 += ltrim(str(DefGridCtrlWidth))
      if language = 1   
         s2 += "'" + rtrim(DefGridCtrlLabel) + "'"
      else
         s2 += "'" + rtrim(DefGridCtrlLabelUK) + "'"
      endif   
      s3 += GetColumnControl(grids, n, m)
   next
   s1 += '}'
   s2 += '}'
   s3 += '}'
   fwrite(printfile, s1 + chr(13) + chr(10))
   fwrite(printfile, s2 + chr(13) + chr(10))
   fwrite(printfile, s3 + chr(13) + chr(10))
   if DefGridReadOnly = "N"
      s := '        allowedit .T.'
      fwrite(printfile, s + chr(13) + chr(10))
   endif
   s := '    end grid'
   fwrite(printfile, s + chr(13) + chr(10))
return(nil)

function GetColumnControl(grids, n, m)
local old := select(), retval := "", classid := 0, bRefcFound, len, i
   // lookup refc
   bRefcFound := .F.
   select 0
   use refc index refc, refcb
   // index tabel + code
   set order to 2
   seek str(nApplid, 10) + padr(DefGridCtrlFieldName, 10)
   if found()
      bRefcFound := .T.
   endif
   use
   select 0
   use prop index propb
   // index clssid+name
   seek str(GetClassId(rtrim(DefGridCtrlObjectName)), 10)+padr(DefGridCtrlFieldName, 10) 
   if found()
      do case
         case bRefcFound
            do case
               case prop->descr = "code" 
                  if DefGridReadOnly = "Y"
                     retval := "{'TEXTBOX','CHARACTER'}"
                  else   
                     retval := "{'COMBOBOX',{}}"
                  endif  
               case prop->descr = "indic"
                  if DefGridReadOnly = "Y"
                     retval := "{'TEXTBOX','CHARACTER'}"
                  else   
                     retval := "{'COMBOBOX',{}}"
                  endif   
               otherwise
                  if DefGridReadOnly = "Y"
                     retval := "{'TEXTBOX','CHARACTER'}"
                  else   
                     retval := "{'COMBOBOX',{}}"
                  endif   
            endcase  
         case prop->descr = "indic"
               if DefGridReadOnly = "Y"
                  retval := "{'TEXTBOX','CHARACTER'}"
               else
                  if language = 1
                     retval := "{'COMBOBOX',{'Ja','Nee'}}"
                  else
                     retval := "{'COMBOBOX',{'Yes','No'}}"
                  endif      
               endif   
         case rtrim(DefGridCtrlInitValue) == '""'
            /* for showing empty string when datatype is numeric and value = 0 */ 
            retval := "{'TEXTBOX','CHARACTER'}"
         case prop->descr = "code"
            if rtrim(prop->TYPE) = 'NUMERIC'
               retval := "{'TEXTBOX','NUMERIC','"  
               len := prop->LENGTH
               for i := 1 to len
                  retval += "9"
               next
               retval += "'}"
            else
               retval := "{'TEXTBOX','CHARACTER'}"
            endif
         case prop->descr = "aantal"     
            retval := "{'TEXTBOX','NUMERIC','"
            len := prop->LENGTH - prop->DEC
            for i := 1 to len
               retval += "9"
            next
            if prop->DEC > 0
               retval += "."
               for i := 1 to prop->DEC
                  retval += "9"
               next      
            endif
            retval += "'}"
         case prop->descr = "nummer" .or. prop->descr = "number"     
            retval := "{'TEXTBOX','NUMERIC','"
            len := prop->LENGTH
            for i := 1 to len
               retval += "9"
            next
            retval += "'}"
         case prop->descr = "id"     
            retval := "{'TEXTBOX','NUMERIC','"
            len := prop->LENGTH
            for i := 1 to len
               retval += "9"
            next
            retval += "'}"
         case prop->descr = "bedrag" .or. prop->descr = "value" 
            retval := "{'TEXTBOX','NUMERIC','"
            len := prop->LENGTH - prop->DEC
            for i := 1 to len
               retval += "9"
            next
            if prop->DEC > 0
               retval += "."
               for i := 1 to prop->DEC
                  retval += "9"
               next      
            endif
            retval += "'}"
         case prop->descr = "perc"     
            retval := "{'TEXTBOX','NUMERIC','"
            len := prop->LENGTH - prop->DEC
            for i := 1 to len
               retval += "9"
            next
            if prop->DEC > 0
               retval += "."
               for i := 1 to prop->DEC
                  retval += "9"
               next      
            endif
            retval += "'}"
         case prop->descr = "datum" .or. prop->descr = "date"     
            if DefGridReadOnly = "Y"
               retval := "{'TEXTBOX','CHARACTER'}"
            else   
               retval := "{'DATEPICKER','DROPDOWN'}"
            endif   
         otherwise
            retval := "{'TEXTBOX','CHARACTER'}"
      endcase 
   else
      do case
         case right(rtrim(DefGridCtrlFieldName), 2) == "ID"
            retval := "{'TEXTBOX','NUMERIC','9999999999'}"
         case rtrim(DefGridCtrlFieldName) == "SEQNO" 
            retval := "{'TEXTBOX','NUMERIC','99'}"
         case IsNumeric(rtrim(DefGridCtrlInitValue)) 
            retval := "{'TEXTBOX','NUMERIC','" +  GetNumericMask(rtrim(DefGridCtrlInitValue)) + "'}"
         case upper(substr(DefGridCtrlInitValue, 1, 5)) == "CTOD(" .or. upper(rtrim(DefGridCtrlInitValue)) == "DATE()"
            retval := "{'DATEPICKER','DROPDOWN'}"
         otherwise   
            retval := "{'TEXTBOX','CHARACTER'}"
      endcase
   endif
   use
   select(old)
return(retval)


/*


   Part 2
   
   
*/


function GenerateDlg(id)
local winname, printfile, dbname, formid, classid, baseobj, objname := "",  filter, ;
bHasGrid, bGridOnly, bGridBaseObject, clname := "", gridname, lbl, filename, ar, Objectname_old
private p, s

select 0
use form index form
formid := id
seek str(formid, 10)
winname := form->FORMCODE
printfile := fcreate("temp.prg")
dbname := GetDbName(rtrim(form->baseobject))
baseobj := rtrim(form->baseobject)
classid := GetClassId(rtrim(form->baseobject))
s := '/*'
fwrite(printfile, s + chr(13) + chr(10))
s := 'This source code has been generated with HMGGEN - Harbour Application Generator.'
fwrite(printfile, s + chr(13) + chr(10))
s := 'Please do not remove the BEGIN and END tags and place your own code between the'
fwrite(printfile, s + chr(13) + chr(10))
s := 'predefined BEGIN and END tags.'
fwrite(printfile, s + chr(13) + chr(10))
s := '*/'
fwrite(printfile, s + chr(13) + chr(10))
s := ''
fwrite(printfile, s + chr(13) + chr(10))
s := '#include "hmg.ch"'
fwrite(printfile, s + chr(13) + chr(10))
s := ''
fwrite(printfile, s + chr(13) + chr(10))
s := 'declare window '
s += winname
fwrite(printfile, s + chr(13) + chr(10))
s := '/* BEGIN */'
fwrite(printfile, s + chr(13) + chr(10))
s := '/* END */'
fwrite(printfile, s + chr(13) + chr(10))
s := ''
fwrite(printfile, s + chr(13) + chr(10))
s := 'function '
s += winname
s += '_OnInit()'
fwrite(printfile, s + chr(13) + chr(10))

/*

   OnInit()
   
*/
bGridOnly := .T.
bHasGrid  := .F.
bGridBaseObject := .F.
select 0
use ctrl index ctrla
seek str(id, 10)
do while .not. eof() .and. ctrl->FORMID = id
   // tbv OnUpdate
   if rtrim(ctrl->CTRLTYPE) == "Textbox" .or. rtrim(ctrl->CTRLTYPE) == "Combobox" ;
   .or. rtrim(ctrl->CTRLTYPE) == "Checkbox" .or. rtrim(ctrl->CTRLTYPE) == "Datepicker"
      if ctrl->READONLY = "N"
         bGridOnly := .F.
      endif   
   endif
   if rtrim(ctrl->CTRLTYPE) == "Grid"
      bHasGrid := .T.
      if rtrim(ctrl->OBJECTNAME) == baseobj
         bGridBaseObject := .T.
      endif
   endif   
   skip
enddo

if classid > 0
   select 0
   use clss index clss
   seek str(classid, 10)
   clname := rtrim(clss->CLASSNAME)
   objname := FirstToLower(clname)
   use
   select("ctrl")
endif

if bHasGrid 
   if bGridOnly
      s := '    local n, aObjects := {}, o'
      s += clname
      fwrite(printfile, s + chr(13) + chr(10))
   elseif bGridBaseObject  
      s := '    local n, aObjects := {}, o'
      s += clname
      s += ', bCondition := {||'
      s += objname
      s += ':id = 0}'   
      fwrite(printfile, s + chr(13) + chr(10))
   else   
      s := '    local n, bCondition := {||'
      if empty(objname)
         s += '.T.}'
      else   
         s += objname
         s += ':id = 0}'   
      endif   
      fwrite(printfile, s + chr(13) + chr(10))
   endif
   HGA210_ClearGrids(id, winname, objname, 4, printfile)
else   
   s := '    local bCondition := {||'
   if empty(objname)
      s += '.T.}'
   else   
      s += objname
      s += ':id = 0}'
   endif   
   fwrite(printfile, s + chr(13) + chr(10))
endif

s := '/* BEGIN */'
fwrite(printfile, s + chr(13) + chr(10))
s := '/* END */'
fwrite(printfile, s + chr(13) + chr(10))

// Load dynamic comboboxes 
seek str(id, 10)
do while .not. eof() .and. ctrl->FORMID = id
   // lookup prop
   select 0
   use prop index propb
   // index clssid+name
   seek str(GetClassId(ctrl->OBJECTNAME), 10)+padr(ctrl->FIELDNAME, 10) 
   if found()
      if rtrim(ctrl->CTRLTYPE) == "Combobox"
         if prop->DESCR = "indic"
         else 
            if IsProductChoice()
               filter := GetChoiceFilterValue()
               s := ''
               if empty(filter)
                  s += '    ComboLoadItems("'
               else
                  s += '    ComboLoadItemsEx("'
               endif
               s += rtrim(ctrl->FIELDNAME)
               s += '", "'
               s += rtrim(ctrl->FIELDNAME)
               s += '", "'
               s += form->FORMCODE
               if !empty(filter)
                  s += '", "'
                  s += rtrim(filter)
               endif   
               s += '")'
               fwrite(printfile, s + chr(13) + chr(10))
            endif   
         endif
      endif
   endif
   use
   select("ctrl")
   skip
enddo
use

if classid > 0
   if bGridOnly 
      HGA210_Grid(id, winname, "o" + clname, 12, printfile, bGridBaseObject)
   else
      s := '    if eval(bCondition)'
      fwrite(printfile, s + chr(13) + chr(10))
      select 0
      use ctrl index ctrla
      seek str(id, 10)
      do while .not. eof() .and. ctrl->FORMID = id
         if substr(ctrl->CTRLTYPE, 1, 7) != "Column " .and. !empty(ctrl->OBJECTNAME)
           // lookup prop
           select 0
           use prop index propb
           seek str(GetClassId(ctrl->OBJECTNAME), 10)+ctrl->FIELDNAME
           if found()
             s := '        '
             s += winname
             s += '.'
             s += rtrim(ctrl->FIELDNAME)
             s += '.value := '
             do case
                case rtrim(ctrl->CTRLTYPE) == "Combobox"
                     if FirstToLower(rtrim(ctrl->OBJECTNAME)) == objname
                        if prop->DESCR = "indic"
                           s += if(ctrl->INITVALUE = "Y", "1", "2")
                           fwrite(printfile, s + chr(13) + chr(10))
                        else
                           if IsProductChoice()
                              if empty(ctrl->INITVALUE) .or. rtrim(ctrl->INITVALUE) == '""'
                                 s += 'ComboLookupDefault("'
                                 s += rtrim(ctrl->FIELDNAME)
                                 s += '", "'
                                 s += rtrim(ctrl->FIELDNAME)
                                 s += '", "'
                                 s += winname
                                 s += '"'
                                 s += ')'
                              else
                                 if isalpha(substr(ctrl->INITVALUE, 1, 1))
                                    s += rtrim(ctrl->INITVALUE)
                                    fwrite(printfile, s + chr(13) + chr(10))
                                 else   
                                    s += 'ComboLookupValue("'
                                    s += rtrim(ctrl->FIELDNAME)
                                    s += '", "'
                                    s += rtrim(ctrl->FIELDNAME)
                                    s += '", "'
                                    s += winname
                                    s += '", '
                                    s += rtrim(ctrl->INITVALUE)
                                    s += ')'
                                 endif
                              endif      
                              fwrite(printfile, s + chr(13) + chr(10))
                           else
                              s += rtrim(ctrl->INITVALUE)
                              fwrite(printfile, s + chr(13) + chr(10))
                           endif      
                        endif   
                     else
                        if prop->DESCR = "indic"
                           s  += 'if('
                           s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                           s += ':'
                           s += rtrim(prop->DESCR)
                           s += ' = "Y", 1, 2)'
                           fwrite(printfile, s + chr(13) + chr(10))
                        else
                           if IsProductChoice()
                              s += 'ComboLookupValue("'
                              s += rtrim(ctrl->FIELDNAME)
                              s += '", "'
                              s += rtrim(ctrl->FIELDNAME)
                              s += '", "'
                              s += winname
                              s += '", '
                              do case
                                 case prop->DESCR = "code"
                                    if rtrim(prop->TYPE) == "NUMERIC"
                                       s += "str("
                                       s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                       s += ':'
                                       s += rtrim(prop->DESCR)
                                       s += ")"
                                    else    
                                       s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                       s += ':'
                                       s += rtrim(prop->DESCR)
                                    endif    
                                 otherwise
                                    s += 'str('
                                    s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                    s += ':'
                                    s += rtrim(prop->DESCR)
                                    s += ')'
                              endcase
                              s += ')'
                              fwrite(printfile, s + chr(13) + chr(10))
                           else
                              if empty(ctrl->ITEMS)
                                 s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                 s += ':'
                                 s += rtrim(prop->DESCR)
                                 fwrite(printfile, s + chr(13) + chr(10))
                              else
                                 s += 'ComboGetValueDirect("'
                                 s += rtrim(ctrl->FIELDNAME)
                                 s += '", "'
                                 s += winname
                                 s += '", '
                                 s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                 s += ':'
                                 s += rtrim(prop->DESCR)
                                 s += ')'
                                 fwrite(printfile, s + chr(13) + chr(10))
                              endif         
                           endif      
                        endif   
                     endif   
                case prop->DESCR = "datum" .or. prop->DESCR = "date"
                     if FirstToLower(rtrim(ctrl->OBJECTNAME)) == objname
                        s += rtrim(ctrl->INITVALUE)
                        fwrite(printfile, s + chr(13) + chr(10))
                     else
                         s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                         s += ':'
                         s += rtrim(prop->DESCR)
                         fwrite(printfile, s + chr(13) + chr(10))
                     endif   
                case prop->DESCR = "aantal" .or. prop->DESCR = "number"
                     if FirstToLower(rtrim(ctrl->OBJECTNAME)) == objname
                        s += rtrim(ctrl->INITVALUE)
                        fwrite(printfile, s + chr(13) + chr(10))
                     else 
                        s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                        s += ':'
                        s += rtrim(prop->DESCR)
                        fwrite(printfile, s + chr(13) + chr(10))
                     endif
                case prop->DESCR = "bedrag" .or. prop->DESCR = "value"
                     if FirstToLower(rtrim(ctrl->OBJECTNAME)) == objname
                        s += rtrim(ctrl->INITVALUE)
                        fwrite(printfile, s + chr(13) + chr(10))
                     else
                         s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                         s += ':'
                         s += rtrim(prop->DESCR)
                         fwrite(printfile, s + chr(13) + chr(10))
                     endif   
                case prop->DESCR = "perc"
                     if FirstToLower(rtrim(ctrl->OBJECTNAME)) == objname
                        s += rtrim(ctrl->INITVALUE)
                        fwrite(printfile, s + chr(13) + chr(10))
                     else
                         s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                         s += ':'
                         s += rtrim(prop->DESCR)
                         fwrite(printfile, s + chr(13) + chr(10))
                     endif      
                otherwise
                     if FirstToLower(rtrim(ctrl->OBJECTNAME)) == objname
                        p := rtrim(ctrl->INITVALUE)
                        do case	
                           case prop->TYPE = "CHARACTER" 	
                              s += rtrim(p)
                           case prop->TYPE = "NUMERIC"
                              s += rtrim(p)
                           case prop->TYPE = "DATE" 	
                              s += rtrim(p)
                        endcase		
                        fwrite(printfile, s + chr(13) + chr(10))
                      else
                         s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                         s += ':'
                         s += rtrim(prop->DESCR)
                         fwrite(printfile, s + chr(13) + chr(10))
                      endif  
              endcase
           endif   
           use
           select("ctrl")
         endif 
         skip
      enddo         
      s := '    else'
      fwrite(printfile, s + chr(13) + chr(10))
      seek str(id, 10)
      do while .not. eof() .and. ctrl->FORMID = id
         if substr(ctrl->CTRLTYPE, 1, 7) != "Column " .and. !empty(ctrl->OBJECTNAME) 
            // lookup prop
            select 0
            use prop index propb
            seek str(GetClassId(ctrl->OBJECTNAME), 10)+ctrl->FIELDNAME
            if found()
              s := '        '
              s += winname
              s += '.'
              s += rtrim(ctrl->FIELDNAME)
              s += '.value := '
              do case
                 case rtrim(ctrl->CTRLTYPE) == "Combobox"
                     if prop->DESCR = "indic"
                        s  += 'if('
                        s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                        s += ':'
                        s += rtrim(prop->DESCR)
                        s += ' = "Y", 1, 2)'
                        fwrite(printfile, s + chr(13) + chr(10))
                     else
                        if IsProductChoice()
                           s += 'ComboLookupValue("'
                           s += rtrim(ctrl->FIELDNAME)
                           s += '", "'
                           s += rtrim(ctrl->FIELDNAME)
                           s += '", "'
                           s += winname
                           s += '", '
                           do case
                              case prop->DESCR = "code"
                                 if rtrim(prop->TYPE) == "NUMERIC"
                                    s += "str("
                                    s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                    s += ':'
                                    s += rtrim(prop->DESCR)
                                    s += ")"
                                 else    
                                    s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                    s += ':'
                                    s += rtrim(prop->DESCR)
                                 endif    
                              otherwise
                                 s += 'str('
                                 s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                 s += ':'
                                 s += rtrim(prop->DESCR)
                                 s += ')'
                           endcase
                           s += ')'
                           fwrite(printfile, s + chr(13) + chr(10))
                        else
                           if empty(ctrl->ITEMS)
                              s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                              s += ':'
                              s += rtrim(prop->DESCR)
                              fwrite(printfile, s + chr(13) + chr(10))
                           else
                              s += 'ComboGetValueDirect("'
                              s += rtrim(ctrl->FIELDNAME)
                              s += '", "'
                              s += winname
                              s += '", '
                              s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                              s += ':'
                              s += rtrim(prop->DESCR)
                              s += ')'
                              fwrite(printfile, s + chr(13) + chr(10))
                           endif         
                        endif      
                     endif   
                 case prop->DESCR = "datum" .or. prop->DESCR = "date"
                      s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                      s += ':'
                      s += rtrim(prop->DESCR)
                      fwrite(printfile, s + chr(13) + chr(10))
                 case prop->DESCR = "aantal" .or. prop->DESCR = "number"
                      s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                      s += ':'
                      s += rtrim(prop->DESCR)
                      fwrite(printfile, s + chr(13) + chr(10))
                 case prop->DESCR = "bedrag" .or. prop->DESCR = "value" 
                      s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                      s += ':'
                      s += rtrim(prop->DESCR)
                      fwrite(printfile, s + chr(13) + chr(10))
                 case prop->DESCR = "perc"
                      s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                      s += ':'
                      s += rtrim(prop->DESCR)
                      fwrite(printfile, s + chr(13) + chr(10))
                 otherwise
                      s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                      s += ':'
                      s += rtrim(prop->DESCR)
                      fwrite(printfile, s + chr(13) + chr(10))
               endcase
            endif   
            use
            select("ctrl")
         endif
         skip
      enddo
      use
      // Load grid items
      if bGridBaseObject
         HGA210_Grid(id, winname, "o" + clname, 16, printfile, bGridBaseObject)
      else
         HGA210_Grid(id, winname, objname, 16, printfile, bGridBaseObject)
      endif   
      s := '    endif'
      fwrite(printfile, s + chr(13) + chr(10))
   endif     
endif
s := '/* BEGIN */'
fwrite(printfile, s + chr(13) + chr(10))
s := '/* END */'
fwrite(printfile, s + chr(13) + chr(10))
s := 'return(nil)'
fwrite(printfile, s + chr(13) + chr(10))
/*

   einde OnInit()
   
*/
   
/*

   OnUpdate()
   
*/
if !bGridOnly
   s := ''
   fwrite(printfile, s + chr(13) + chr(10))
   s := 'function '
   s += winname
   s += '_OnUpdate('
   s += objname 
   s += ')'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '/* BEGIN */'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '/* END */'
   fwrite(printfile, s + chr(13) + chr(10))
   use ctrl index ctrla
   seek str(id, 10)
   do while .not. eof() .and. ctrl->FORMID = id
      if !empty(ctrl->OBJECTNAME) .and. rtrim(ctrl->OBJECTNAME) == clname
        if classid > 0
           // lookup prop
           select 0
           use prop index propb
           seek str(classid, 10)+ctrl->FIELDNAME
           if found() .and. !empty(ctrl->OBJECTNAME)
              s := '    '
              s += objname
              s += ':'
              s += rtrim(prop->DESCR)
              s += ' := '
              do case 
                  case rtrim(ctrl->CTRLTYPE) == "Combobox"
                     if prop->DESCR = "indic"
                        s += 'if(' 
                        s += winname
                        s += '.'
                        s += rtrim(ctrl->FIELDNAME)
                        s += '.value'
                        s += ' = 1, "Y", "N")'
                        fwrite(printfile, s + chr(13) + chr(10))
                     else
                        if IsProductChoice()
                           do case
                              case prop->DESCR = "code"
                                 if rtrim(prop->TYPE) == "NUMERIC"
                                    s += "val("
                                 endif   
                                 s += 'ComboGetCode("'
                                 s += rtrim(ctrl->FIELDNAME)
                                 s += '", "'
                                 s += rtrim(ctrl->FIELDNAME)
                                 s += '", "'
                                 s += winname
                                 s += '")'
                                 if rtrim(prop->TYPE) == "NUMERIC"
                                    s += ")"
                                 endif   
                                 fwrite(printfile, s + chr(13) + chr(10))
                              otherwise  
                                 s += 'val('
                                 s += 'ComboGetCode("'
                                 s += rtrim(ctrl->FIELDNAME)
                                 s += '", "'
                                 s += rtrim(ctrl->FIELDNAME)
                                 s += '", "'
                                 s += winname
                                 s += '"))'
                                 fwrite(printfile, s + chr(13) + chr(10))
                           endcase
                        else
                           if empty(ctrl->ITEMS)
                              s += winname
                              s += '.'
                              s += rtrim(ctrl->FIELDNAME)
                              s += '.value'
                              fwrite(printfile, s + chr(13) + chr(10))
                           else
                              s += winname
                              s += '.'
                              s += rtrim(ctrl->FIELDNAME)
                              s += '.Item('
                              s += winname
                              s += '.'
                              s += rtrim(ctrl->FIELDNAME)
                              s += '.value'
                              s += ')'
                              fwrite(printfile, s + chr(13) + chr(10))
                           endif         
                        endif      
                     endif   
                  case prop->DESCR = "datum" .or. prop->DESCR = "date"
                     s += winname
                     s += '.'
                     s += rtrim(ctrl->FIELDNAME)
                     s += '.value'
                     fwrite(printfile, s + chr(13) + chr(10))
                  case prop->DESCR = "aantal" .or. prop->DESCR = "number"
                     s += winname
                     s += '.'
                     s += rtrim(ctrl->FIELDNAME)
                     s += '.value'
                     fwrite(printfile, s + chr(13) + chr(10))
                  case prop->DESCR = "bedrag" .or. prop->DESCR = "value"
                     s += winname
                     s += '.'
                     s += rtrim(ctrl->FIELDNAME)
                     s += '.value'
                     fwrite(printfile, s + chr(13) + chr(10))
                  case prop->DESCR = "perc"
                     s += winname
                     s += '.'
                     s += rtrim(ctrl->FIELDNAME)
                     s += '.value'
                     fwrite(printfile, s + chr(13) + chr(10))
                  otherwise
                     s += winname
                     s += '.'
                     s += rtrim(ctrl->FIELDNAME)
                     s += '.value'
                     fwrite(printfile, s + chr(13) + chr(10))
              endcase
           endif   
           use
        endif   
        select("ctrl")
     endif
     skip
   enddo         
   use
   s := '/* BEGIN */'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '/* END */'
   fwrite(printfile, s + chr(13) + chr(10))
   s := 'return(nil)'
   fwrite(printfile, s + chr(13) + chr(10))
endif
/*

   einde OnUpdate()
   
*/

select("form")
use

/*

   On<Button>()
   
*/
use ctrl index ctrla
seek str(id, 10)
do while .not. eof() .and. ctrl->FORMID = id
   do case 
      case rtrim(ctrl->CTRLTYPE) == "Grid"
         gridname := ctrl->FIELDNAME      
      case rtrim(ctrl->CTRLTYPE) == "Button"
         if ctrl->ONACTION = "Y" 
         	lbl := rtrim(ctrl->FIELDNAME)
         	s := ''
         	fwrite(printfile, s + chr(13) + chr(10))
         	s := 'function '
         	s += winname
         	if rtrim(ctrl->ALIGNMENT) == "Left"
            	s += '_'
            	s += rtrim(gridname)
         	endif   
         	if rtrim(ctrl->ALIGNMENT) != "Left" .and. lbl == "Update"
            	s += '_'
            	s += lower(lbl)
         	endif   
         	s += '_On'
         	s += lbl
         	s += '()'
         	fwrite(printfile, s + chr(13) + chr(10))
         	s := '/* BEGIN */'
         	fwrite(printfile, s + chr(13) + chr(10))
         	s := '/* END */'
         	fwrite(printfile, s + chr(13) + chr(10))
         	do case
            	case lbl = "Apply" 
                  if !bGridOnly
                     s := '   '
                     s += winname
                     s += '_OnUpdate('
                     s += objname
                     s += ')'
                     fwrite(printfile, s + chr(13) + chr(10))
                  endif   
            	case lbl = "Cancel" 
               	s := '   '
               	s += winname
               	s += '_OnInit()'
               	fwrite(printfile, s + chr(13) + chr(10))
            	case lbl = "Next" 
                  if !bGridOnly
                     s := '   '
                     s += winname
                     s += '_OnUpdate('
                     s += objname
                     s += ')'
                     fwrite(printfile, s + chr(13) + chr(10))
                  endif   
            	case lbl = "Back" 
                  if !bGridOnly
                     s := '   '
                     s += winname
                     s += '_OnUpdate('
                     s += objname
                     s += ')'
                     fwrite(printfile, s + chr(13) + chr(10))
                  endif   
               	s := '   '
               	s += winname
               	s += '.Hide'
               	fwrite(printfile, s + chr(13) + chr(10))
         	endcase
         	s := '/* BEGIN */'
         	fwrite(printfile, s + chr(13) + chr(10))
         	s := '/* END */'
         	fwrite(printfile, s + chr(13) + chr(10))
         	s := 'return(nil)'
         	fwrite(printfile, s + chr(13) + chr(10))
         endif
   endcase
   skip
enddo
use
/*

   einde On<Button>()
   
*/

/*

   OnChange<control>()
   
*/
use ctrl index ctrla
seek str(id, 10)
do while .not. eof() .and. ctrl->FORMID = id
   do case 
	case rtrim(ctrl->CTRLTYPE) == "Textbox" .or. rtrim(ctrl->CTRLTYPE) == "Combobox"
         if ctrl->ONCHANGE = "Y"		
         	s := ''
         	fwrite(printfile, s + chr(13) + chr(10))
         	s := 'function '
         	s += winname
            s += "_"
            s += rtrim(ctrl->FIELDNAME)	
         	s += '_OnChange()'
         	fwrite(printfile, s + chr(13) + chr(10))
         	s := '/* BEGIN */'
         	fwrite(printfile, s + chr(13) + chr(10))
         	s := '/* END */'
         	fwrite(printfile, s + chr(13) + chr(10))
         	s := 'return(nil)'
         	fwrite(printfile, s + chr(13) + chr(10))
	   endif
   endcase
   skip
enddo
use
/*

   einde OnChange<control>()
   
*/
s := ''
fwrite(printfile, s + chr(13) + chr(10))
s := 'function '
s += winname
s += '_OnClose()'
fwrite(printfile, s + chr(13) + chr(10))
s := '/* BEGIN */'
fwrite(printfile, s + chr(13) + chr(10))
s := '/* END */'
fwrite(printfile, s + chr(13) + chr(10))
s := 'return(.T.)'
fwrite(printfile, s + chr(13) + chr(10))

/* tbv extra functies */

filename := winname + ".prg" 

if !file(filename)
   s := ''
   fwrite(printfile, s + chr(13) + chr(10))
   s := '/* BEGIN */'
   fwrite(printfile, s + chr(13) + chr(10))
   s := '/* END */'
   fwrite(printfile, s + chr(13) + chr(10))
endif

fclose(printfile)
ar := {}
if file(filename)
   SaveCode(filename, ar)
   MergeCode("temp.prg", filename, ar)
else
   copy file temp.prg to (filename)
endif
return(nil)

function SaveCode(outputfile, ar)
local old := select(), handle, cur, eof, filename, rec, bBegin, bFirstBlock, bWithinClass, n, m, pos1, pos2, name
handle = fopen(outputfile,0)
eof    = fseek(handle,0,2)
cur    = fseek(handle,0,0)
rec := LeesRec(@handle, @cur, @eof, @rec)
bBegin := .F.
bFirstBlock := .T.
bWithinClass := .F.
do while cur < eof
   do case
      case lower(substr(ltrim(rec),1,9)) == "function "
         if bBegin
            /* udf's */
            if bFirstBlock
               aadd(ar, {"udfblocks", {}})
               bFirstBlock := .F.
            endif   
            aadd(ar[len(ar), 2], {})
            n := len(ar)
            m := len(ar[n, 2])
            aadd(ar[n, 2, m], rec)
         else
            pos1 := at(" ", rec) + 1
            pos2 := at("(", rec)
            name := substr(rec, pos1, pos2-pos1)
            aadd(ar, {name, {}})
         endif   
      case lower(substr(ltrim(rec),1,7)) == "method "
         if bWithinClass
            if bBegin
               n := len(ar)
               m := len(ar[n, 2])
               aadd(ar[n, 2, m], rec)
            endif
        else
            if bBegin
               /* udf's */
               if bFirstBlock
                  aadd(ar, {"udfblocks", {}})
                  bFirstBlock := .F.
               endif   
               aadd(ar[len(ar), 2], {})
               n := len(ar)
               m := len(ar[n, 2])
               aadd(ar[n, 2, m], rec)
            else
               pos1 := at(" ", rec) + 1
               pos2 := at("(", rec)
               name := substr(rec, pos1, pos2-pos1)
               aadd(ar, {name, {}})
            endif
          endif     
      case lower(substr(ltrim(rec),1,6)) == "class " 
         bWithinClass := .T.
         if bBegin
            /* udf's */
            if bFirstBlock
               aadd(ar, {"udfblocks", {}})
               bFirstBlock := .F.
            endif   
            aadd(ar[len(ar), 2], {})
            n := len(ar)
            m := len(ar[n, 2])
            aadd(ar[n, 2, m], rec)
         else
            pos1 := at(" ", rec) + 1
            name := substr(rec, pos1)
            aadd(ar, {name, {}})
         endif   
      case lower(substr(ltrim(rec),1,9)) == "endclass "
         bWithinClass := .F.
      case ltrim(rec) = "/* BEGIN */"
         if len(ar) > 0
            if ar[len(ar), 1] == "udfblocks"
            else
               aadd(ar[len(ar), 2], {})
            endif   
         else
            aadd(ar, {"declarations", {}})
            aadd(ar[len(ar), 2], {})
         endif   
         bBegin := .T.
      case ltrim(rec) = "/* END */"
         bBegin := .F.
      otherwise
         if bBegin
            n := len(ar)
            m := len(ar[n, 2])
            aadd(ar[n, 2, m], rec)
         endif
   endcase      
   rec := LeesRec(@handle, @cur, @eof, @rec)
enddo   
fclose(handle)
select(old)
return(nil)

function MergeCode(tempfile, outputfile, ar)
local old := select(), handle, cur, eof, filename, rec, n, m, p, name, pos1, pos2, bWithinClass, bFirstLine, printfile
handle = fopen(tempfile,0)
eof    = fseek(handle,0,2)
cur    = fseek(handle,0,0)
printfile := fcreate(outputfile)
rec := LeesRec(@handle, @cur, @eof, @rec)
name := ""
m := 1
bWithinClass := .F.
do while cur < eof
   fwrite(printfile, rec + chr(13) + chr(10))
   do case
      case lower(substr(ltrim(rec),1,9)) == "function "
         pos1 := at(" ", rec) + 1
         pos2 := at("(", rec)
         name := substr(rec, pos1, pos2-pos1)
         m := 1
      case lower(substr(ltrim(rec),1,7)) == "method "
         if bWithinClass
         else
            pos1 := at(" ", rec) + 1
            pos2 := at("(", rec)
            name := substr(rec, pos1, pos2-pos1)
            m := 1
         endif   
      case lower(substr(ltrim(rec),1,6)) == "class "          
         bWithinClass := .T.
         pos1 := at(" ", rec) + 1
         name := substr(rec, pos1)
         m := 1
      case lower(substr(ltrim(rec),1,9)) == "endclass "
         bWithinClass := .F.
      case ltrim(rec) = "/* BEGIN */"   
         // lookup function, method or declaration
         if empty(name) 
            n := ascan(ar, {|x|x[1] == "declarations"})
         else
            n := ascan(ar, {|x|x[1] == name})
         endif
         if n > 0
            if m <= len(ar[n, 2])
               for p := 1 to len(ar[n, 2, m])
                  fwrite(printfile, ar[n, 2, m, p] + chr(13) + chr(10))
                  ar[n, 2, m, p] := "**merged**"
               next
            endif
            m++
         endif
   endcase      
   rec := LeesRec(@handle, @cur, @eof, @rec)
enddo
// tbv udf's
fwrite(printfile, chr(13) + chr(10))
fwrite(printfile, "/* BEGIN */" + chr(13) + chr(10))
for n := 1 to len(ar)
   for m := 1 to len(ar[n, 2])
      bFirstLine := .T.
      for p := 1 to len(ar[n, 2, m])
         if ar[n, 2, m, p] != "**merged**"
            if bFirstLine
               fwrite(chr(13) + chr(10))
               bFirstLine := .F.      
            endif
            fwrite(printfile, ar[n, 2, m, p] + chr(13) + chr(10)) // hier komen 2 laatste blokken in terecht !!!!
         endif   
      next   
   next
next   
fwrite(printfile, "/* END */" + chr(13) + chr(10))
fclose(printfile)
fclose(handle)
select(old)
return(nil)

function LeesRec(handle, cur, eof, rec)
local char1 := "", char2 := ""
   rec := ""
   do while cur < eof .and. char1 <> chr(13) .and. char2 <> chr(10)
      char1 = freadstr(handle,1)
      cur   = fseek(handle,0,1)
      if char1 = chr(13)
         char2 = freadstr(handle,1)
         if char2 <> chr(10)
            rec = rec + char1
         endif
      else
         rec = rec + char1
      endif
   enddo
return(rec)

function IsProductChoice()
   local old := select(), retval  := .F.
   if rtrim(ctrl->FIELDNAME) == "BEHANDTEAM" .or. rtrim(ctrl->FIELDNAME) == "ROL"
      retval := .T.
   else   
      select 0
      use refc index refc, refcb
      // index tabel + code
      set order to 2
      seek str(nApplid, 10) + padr(ctrl->FIELDNAME, 10)
      if found()
         retval := .T.
      endif 
      use
   endif   
   select(old)
return(retval)

function GetChoiceFilterValue()
   local old := select(), filter, filtervalue := ""
   select 0
   use refc index refc, refcb
   // index tabel + code
   set order to 2
   seek str(nApplid, 10) + padr(ctrl->FIELDNAME, 10)
   if found()
      if !empty(refc->REFTABEL)
         filter := refc->REFTABEL
         go top
         do while .not. eof()
            if filter = padr(refc->TABEL, 10)
               if refc->DEFAULT = "Y"
                   filtervalue = rtrim(refc->CODE)
                   exit
               endif
            endif     
            skip
         enddo   
      endif
   endif 
   use
   select(old)
return(filtervalue)

function GetChoiceDefaultValue()
   local old := select(), filter, filtervalue := "", default := "", recno 
   select 0
   use refc index refc, refcb
   // index tabel + code
   set order to 2
   seek str(nApplid, 10) + padr(ctrl->FIELDNAME, 10)
   do while .not. eof() .and. refc->TABEL == padr(ctrl->FIELDNAME, 10)
      if empty(refc->REFTABEL)
         /* no filter */
         if refc->DEFAULT = "Y"
            default := rtrim(refc->CODE)
            exit
         endif
      else
         filter := refc->REFTABEL
         recno := recno()
         go top
         do while .not. eof()
            if filter = padr(refc->TABEL, 10)
               if refc->DEFAULT = "Y"
                  filtervalue = rtrim(refc->CODE)
                  exit
               endif
            endif     
            skip
         enddo
         go recno   
         if rtrim(refc->REF) == filtervalue .and. refc->DEFAULT = "Y"
            default := rtrim(refc->CODE)
            exit
         endif
      endif   
      skip
   enddo       
   use
   select(old)   
return(default)

function LookupForm(formcode)
   local old := select(), retval := 0
   select 0
   use form
   do while .not. eof() 
      if form->APPLID = nApplid .and. rtrim(form->FORMCODE) == rtrim(formcode)
         retval := rtrim(form->ID)
         exit
      endif   
      skip
   enddo
   use
   select(old)
return(retval)

function HGA210_Grid(id, winname, objname, indent, printfile, bGridBaseObject)     
   local old := select(), s, objectname_grid := "", bFinish := .F.
   select 0
   use ctrl index ctrla
   seek str(id, 10)
   do while .not. eof() .and. ctrl->FORMID = id
      if rtrim(ctrl->CTRLTYPE) == "Grid" .or. rtrim(ctrl->CTRLTYPE) = "Column "
         // lookup prop
         select 0
         use prop index propb
         seek str(GetClassId(ctrl->OBJECTNAME), 10)+ctrl->FIELDNAME
         if found() .or. rtrim(ctrl->CTRLTYPE) == "Grid"
            do case 
               case rtrim(ctrl->CTRLTYPE) == "Grid"
                  if bFinish .and. !empty(objectname_grid)
                     s := space(indent)
                     s += objname
                     s += ':'
                     if indent = 16 .and. !bGridBaseObject
                        s += FirstToLower(GetCollClass(objectname_grid))
                        s += '[n]'
                        s += ':'
                     endif   
                     s += 'id ;'
                     fwrite(printfile, s + chr(13) + chr(10))
                     s := space(indent - 4)
                     s += '})'   
                     fwrite(printfile, s + chr(13) + chr(10))
                     s := space(indent - 8)
                     s += 'next'     
                     fwrite(printfile, s + chr(13) + chr(10))
                  endif 
                  bFinish := .T.   
                  s := space(indent - 8)
                  s += 'for n := 1 to len('
                  if indent = 16 .and. !bGridBaseObject
                     s += objname
                     s += ':'
                     s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                  else 
                     s += 'aObjects'   
                  endif   
                  s += ')' 
                  fwrite(printfile, s + chr(13) + chr(10))
                  if indent = 16 .and. !bGridBaseObject
                  else
                     s := space(indent - 4)
                     s += objname
                     s += ' := aObjects[n]'
                     fwrite(printfile, s + chr(13) + chr(10))
                  endif
                  s := space(indent - 4)
                  s += winname
                  s += '.'
                  s += rtrim(ctrl->FIELDNAME)
                  s += '.AddItem({ ;'
                  fwrite(printfile, s + chr(13) + chr(10))
                  objectname_grid := ctrl->OBJECTNAME
               case rtrim(ctrl->CTRLTYPE) == "Column textbox"
                  do case
                     case prop->DESCR = "code"
                        if IsproductChoice()
                           s := space(indent)
                           s += 'ComboLookupDescr("'
                           s += rtrim(ctrl->FIELDNAME)
                           s += '", '
                           if rtrim(prop->TYPE) == "NUMERIC"
                              s += "str("
                           endif   
                           s += objname
                           s += ':'
                           if indent = 16 .and. !bGridBaseObject
                              if rtrim(ctrl->OBJECTNAME) == rtrim(objectname_grid)
                                 s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                                 s += '[n]'
                                 s += ':'
                              else
                                 s +=  FirstToLower(GetCollClass(objectname_grid))
                                 s += '[n]'
                                 s += ':'
                                 s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                 s += ':'
                              endif
                           endif         
                           s += rtrim(prop->DESCR)
                           if rtrim(prop->TYPE) == "NUMERIC"
                              s += ")"
                           endif    
                           s += '), ;'
                           fwrite(printfile, s + chr(13) + chr(10))
                        else
                           s := space(indent)
                           s += objname
                           s += ':'
                           if indent = 16 .and. !bGridBaseObject
                              if rtrim(ctrl->OBJECTNAME) == rtrim(objectname_grid)
                                 s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                                 s += '[n]'
                                 s += ':'
                              else
                                 s +=  FirstToLower(GetCollClass(objectname_grid))
                                 s += '[n]'
                                 s += ':'
                                 s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                 s += ':'
                              endif   
                           endif   
                           s += rtrim(prop->DESCR)
                           s += ', ;'
                           fwrite(printfile, s + chr(13) + chr(10))
                        endif 
                     case prop->DESCR = "indic"
                        s := space(indent)
                        s += 'if('
                        s += objname
                        s += ':'
                        if indent = 16 .and. !bGridBaseObject
                           if rtrim(ctrl->OBJECTNAME) == rtrim(objectname_grid)
                              s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                              s += '[n]'
                              s += ':'
                           else
                              s +=  FirstToLower(GetCollClass(objectname_grid))
                              s += '[n]'
                              s += ':'
                              s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                              s += ':'
                           endif      
                        endif   
                        s += rtrim(prop->DESCR)
                        s += ' = "Y", "Yes", "No"), ;'
                        fwrite(printfile, s + chr(13) + chr(10))
                     otherwise
                        s := space(indent)
                        /* for showing empty string when initvalue = 0 */ 
                        if rtrim(prop->TYPE) == "NUMERIC" .and. rtrim(ctrl->INITVALUE) == '""'
                           s += "str("
                        endif   
                        s += objname
                        s += ':'
                        if indent = 16 .and. !bGridBaseObject
                           if rtrim(ctrl->OBJECTNAME) == rtrim(objectname_grid)
                              s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                              s += '[n]'
                              s += ':'
                           else
                              s +=  FirstToLower(GetCollClass(objectname_grid))
                              s += '[n]'
                              s += ':'
                              s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                              s += ':'
                           endif   
                        endif   
                        s += rtrim(prop->DESCR)
                        if rtrim(prop->TYPE) == "NUMERIC" .and. rtrim(ctrl->INITVALUE) == '""'
                           s += ")"
                        endif   
                        s += ', ;'
                        fwrite(printfile, s + chr(13) + chr(10))
                  endcase      
               case rtrim(ctrl->CTRLTYPE) == "Column combobox"
                  if prop->DESCR = "indic"
                     s := space(indent)
                     s += 'if('
                     s += objname
                     s += ':'
                     if indent = 16 .and. !bGridBaseObject
                        if rtrim(ctrl->OBJECTNAME) == rtrim(objectname_grid)
                           s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                           s += '[n]'
                           s += ':'
                        else
                           s +=  FirstToLower(GetCollClass(objectname_grid))
                           s += '[n]'
                           s += ':'
                           s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                           s += ':'
                        endif      
                     endif   
                     s += rtrim(prop->DESCR)
                     s += ' = "Y", 1, 2), ;'
                     fwrite(printfile, s + chr(13) + chr(10))
                  else
                     s := space(indent)
                     s += 'GridComboLookupValue("'
                     s += rtrim(ctrl->FIELDNAME)
                     s += '", '
                     do case
                        case prop->DESCR = "code"
                           if rtrim(prop->TYPE) == "NUMERIC"
                              s += "str("
                           endif   
                           s += objname
                           s += ':'
                           if indent = 16 .and. !bGridBaseObject
                              if rtrim(ctrl->OBJECTNAME) == rtrim(objectname_grid)
                                 s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                                 s += '[n]'
                                 s += ':'
                              else
                                 s +=  FirstToLower(GetCollClass(objectname_grid))
                                 s += '[n]'
                                 s += ':'
                                 s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                 s += ':'
                              endif      
                           endif   
                           s += rtrim(prop->DESCR)
                           if rtrim(prop->TYPE) == "NUMERIC"
                              s += ")"
                           endif    
                        otherwise
                           s += 'str('
                           s += objname
                           s += ':'
                           if indent = 16 .and. !bGridBaseObject
                              if rtrim(ctrl->OBJECTNAME) == rtrim(objectname_grid)
                                 s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                                 s += '[n]'
                                 s += ':'
                              else
                                 s +=  FirstToLower(GetCollClass(objectname_grid))
                                 s += '[n]'
                                 s += ':'
                                 s += FirstToLower(rtrim(ctrl->OBJECTNAME))
                                 s += ':'
                              endif            
                           endif   
                           s += rtrim(prop->DESCR)
                           s += ')'
                     endcase
                     s += '), ;'
                     fwrite(printfile, s + chr(13) + chr(10))
                  endif   
            endcase 
         else
            do case
               case rtrim(ctrl->FIELDNAME) == "TXDATE"
                  s := space(indent)
                  s += 'dtoc('
                  s += objname
                  s += ':'
                  if indent = 16 .and. !bGridBaseObject
                     s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                     s += '[n]'
                     s += ':'
                  endif   
                  s += 'txdate)'
                  s += ', ;'
                  fwrite(printfile, s + chr(13) + chr(10))
               case rtrim(ctrl->FIELDNAME) == "TXTIME"
                  s := space(indent)
                  s += objname
                  s += ':'
                  if indent = 16 .and. !bGridBaseObject
                     s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                     s += '[n]'
                     s += ':'
                  endif   
                  s += 'txtime'
                  s += ', ;'
                  fwrite(printfile, s + chr(13) + chr(10))
               case len(rtrim(ctrl->FIELDNAME)) = 6 .and. substr(ctrl->FIELDNAME, 5, 2) == "ID"
                  /* field is foreign key */
                  s := space(indent)
                  s += objname
                  s += ':'
                  if indent = 16 .and. !bGridBaseObject
                     s += FirstToLower(GetCollClass(ctrl->OBJECTNAME))
                     s += '[n]'
                     s += ':'
                  endif   
                  s += FirstToLower(LookupClassOfDbname(substr(ctrl->FIELDNAME, 1, 4)))
                  s += ':id'
                  s += ', ;'
                  fwrite(printfile, s + chr(13) + chr(10))
            endcase   
         endif
         use
         select("ctrl")
      endif   
      skip
   enddo
   if bFinish .and. !empty(objectname_grid)
      s := space(indent)
      s += objname
      s += ':'
      if indent = 16 .and. !bGridBaseObject
         s += FirstToLower(GetCollClass(objectname_grid))
         s += '[n]'
         s += ':'
      endif   
      s += 'id ;'
      fwrite(printfile, s + chr(13) + chr(10))
      s := space(indent - 4)
      s += '})'   
      fwrite(printfile, s + chr(13) + chr(10))
      s := space(indent - 8)
      s += 'next'     
      fwrite(printfile, s + chr(13) + chr(10))
   endif   
   use
   select(old)
return(nil)

function HGA210_ClearGrids(id, winname, objname, indent, printfile)     
   local s
   seek str(id, 10)
   do while .not. eof() .and. ctrl->FORMID = id
	  if rtrim(ctrl->CTRLTYPE) == "Grid"
         s := space(indent)
         s += winname
         s += '.'
         s += rtrim(ctrl->FIELDNAME)
         s += '.DeleteAllItems'
         fwrite(printfile, s + chr(13) + chr(10))
      endif
      skip
   enddo
return(nil)   