#include <hmg.ch>

declare window HGA220

Function HGA220_OnInit()
   select 0
   use clss index clssa
   do while .not. eof()
      if clss->APPLID = nApplid
         HGA220.grid_1.AddItem({0, clss->CLASSNAME, clss->DBNAME, ID})
      endif   
      skip
   enddo
   use
Return nil

Function HGA220_OnChange()
   /* let erop dat item reserved word is ! */
   item1 := HGA220.grid_1.Item(HGA220.grid_1.Value)
   if item1[1] = 0
      item1[1] := 1
   else
      item1[1] := 0
   endif
   /* terugzetten blijkbaar nodig */   
   HGA220.grid_1.Item(HGA220.grid_1.Value) := item1
Return Nil

Function HGA220_OnGenerate()
   local n
   for n := 1 to HGA220.grid_1.ItemCount
      item := HGA220.grid_1.Item(n)
      if item[1] = 1
         GenerateObject(item[4])
      endif 
   next
   HGA220.Hide
   HGA220.Release
Return nil

Function GenerateObject(id)
   /* static variables outside the functions don't work because the macro compliler & needs them */
   public filename, classname, collclass, classid, dbname, parent, superclass, parentid, struct := {}
   select 0
   use clss index clss
   select 0
   use prop index propa
   select("CLSS")
   classid := id
   seek str(classid, 10)
   filename := rtrim(clss->DBNAME)
   classname := rtrim(clss->CLASSNAME)
   collclass = rtrim(clss->COLLCLASS)
   parent := rtrim(clss->PARENT)
   /* bug: len(parent) = 40 ???? */
   superclass := rtrim(LookupDbname(clss->SUPERCLASS))
   parentid := rtrim(lower(LookupDbname(parent))) + "id"
   select("PROP")
   seek str(classid, 10)
   do while .not. eof() .and. prop->CLSSID = classid
      aadd(struct, {rtrim(prop->NAME), rtrim(prop->DESCR), prop->TYPE, prop->LENGTH, prop->DEC, ;
      rtrim(prop->DBNAME), rtrim(prop->MULTIPL)})
      skip
   enddo
   use
   select("CLSS")
   use
   VerwerkTemplate()
return(nil)

function VerwerkTemplate()
   local templname, handle, cur, eof, rec, bOpsparen := .F., s, chars, char := "", char_oud
   private content
   templname = "hg_template_class.txt"
   // openen DOS-handle
   handle = fopen(templname,0)
   eof    = fseek(handle,0,2)
   cur    = fseek(handle,0,0)
   // open DOS-filehandle
   printfile := fcreate("temp.prg")
   do while cur < eof
      char_oud := char    
      char := freadstr(handle,1)
      cur  = fseek(handle,0,1)
      if char_oud = '[' .and. char = "_"
         // opsparen in content
         content := ""
         bOpsparen := .T.
      elseif char_oud = ']' .and. bOpsparen
         // s:= met macro geexpandeerde content
         content := substr(content, 2)
         s := &content.
         for m := 1 to len(s)    
            fwrite(printfile, substr(s, m, 1))
         next
         bOpsparen := .F.
      else
         if bOpsparen
            content += char_oud
         else
            fwrite(printfile, char_oud)
         endif
      endif   
   enddo
   fwrite(printfile, char)
   filename := "c" + lower(filename) + ".prg" 
   if !file(filename)
      s := '/* BEGIN */'
      fwrite(printfile, s + chr(13) + chr(10))
      s := '/* END */'
      fwrite(printfile, s + chr(13) + chr(10))
   endif
   fclose(templname)
   fclose(printfile)
   ar := {}
   if file(filename)
      SaveCode(filename, ar)
      MergeCode("temp.prg", filename, ar)
   else
      copy file temp.prg to (filename)
   endif
return(nil)

function incltb1()
   local s, n
   // Transfer()
   // reglement:codeProduct := regl->PRODCODE
   for n:= 1 to len(struct)
      if struct[n, 6] == filename
         s := ''
         s += '   self:'
         s += struct[n, 2]
         s += ' := '
         if struct[n, 3] = "C"
            s += 'rtrim('
            s += lower(filename)
            s += '->'
            s += struct[n, 1]
            s += ')'
         else
            s += lower(filename)
            s += '->'
            s += struct[n, 1]
         endif
         fwrite(printfile, s + chr(13) + chr(10))
      endif   
   next
return("")

function incltb2()
   local s, n, m
   //  data 
   for n:= 1 to len(struct)
      s := ''
      s += '   data '
      s += struct[n, 2]
      fwrite(printfile, s + chr(13) + chr(10))
   next
return("")

function incltb3()
   local s, n
   // Equals()
   for n:= 1 to len(struct)
      if struct[n, 6] == filename
         s := ''
         s += '   if self:'
         s += struct[n, 2]
         s += ' != old_rec:'
         s += struct[n, 2]
         fwrite(printfile, s + chr(13) + chr(10))
         s := ''
         s += '      retval := .F.'
         fwrite(printfile, s + chr(13) + chr(10))
         s := ''
         s += '   endif'
         fwrite(printfile, s + chr(13) + chr(10))
      endif   
   next
return("")

function incltb4()
   local s, n
   // Replace()
   // regl->PRODCODE := self:codeProduct
   for n:= 1 to len(struct)
      if struct[n, 6] == filename
         s := ''
         s += '   '
         s += lower(filename)
         s += '->'
         s += struct[n, 1]
         s += ' := self:'
         s += struct[n, 2]
         fwrite(printfile, s + chr(13) + chr(10))
      endif   
   next
return("")

function incltb5()
   local s, n
   // LogChanges()
   for n:= 1 to len(struct)
      if struct[n, 6] == filename
         s := ''
         s += '   if self:'
         s += struct[n, 2]
         s += ' != old_rec:'
         s += struct[n, 2]
         fwrite(printfile, s + chr(13) + chr(10))
         s := ''
         s += '      DbfLogAdd(alias(), "'
         s += struct[n, 1]
         s += '", old_rec:id, '
         do case
            case struct[n, 3] = "C"
               s += 'old_rec:'
               s += struct[n, 2]
            case struct[n, 3] = "N"
               s += 'str(old_rec:'
               s += struct[n, 2]
               s += ')'
            case struct[n, 3] = "D"   
               s += 'dtoc(old_rec:'
               s += struct[n, 2]
               s += ')'
         endcase
         s += ', old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)'
         fwrite(printfile, s + chr(13) + chr(10))
         s := ''
         s += '   endif'
         fwrite(printfile, s + chr(13) + chr(10))
      endif   
   next
return("")

function incltb6()
   local s, n
   // Get()
   for n := 1 to len(struct) 
      if struct[n, 6] == filename
         /* Do nothing */
      else
         if empty(struct[n, 6])
            /* Do nothing */
         else   
            if struct[n, 7] == "1"
               s := '      if requestor != "'
               s += FirstToLower(struct[n, 2])
               s += '"'
               fwrite(printfile, s + chr(13) + chr(10))
               s := '         '
               s += GetCollClass(FirstToUpper(struct[n, 2]))
               s += '():Get('
               s += lower(rtrim(filename))
               s += '->'
               s += upper(struct[n, 6])
               s += 'ID, '
               s += FirstToLower(classname)
               s += ':'
               s += struct[n, 2]
               s += ', "'
               s += FirstToLower(classname)
               s += '", refdat)'
               fwrite(printfile, s + chr(13) + chr(10))
               s := '      endif'
               fwrite(printfile, s + chr(13) + chr(10))
            else 
               s := '      if requestor != "'
               s += FirstToLower(GetClassName(FirstToUpper(struct[n, 2])))
               s += '"'
               fwrite(printfile, s + chr(13) + chr(10))
               s := '         '
               s += FirstToUpper(struct[n, 2])
               s += '():Find(id, '
               s += FirstToLower(rtrim(classname))
               s += ':'
               s += struct[n, 2]
               s += ', refdat)'
               fwrite(printfile, s + chr(13) + chr(10))
               s := '         for n := 1 to len('
               s += FirstToLower(rtrim(classname))
               s += ':'
               s += struct[n, 2]
               s += ')'
               fwrite(printfile, s + chr(13) + chr(10))
               s := '            '
               s += FirstToUpper(struct[n, 2])
               s += '():Get('
               s += FirstToLower(rtrim(classname))
               s += ':'
               s += struct[n, 2]
               s += '[n]:id, '
               s += FirstToLower(rtrim(classname))
               s += ':'
               s += struct[n, 2]
               s += '[n], "'
               s += FirstToLower(rtrim(classname))
               s += '", refdat)'
               fwrite(printfile, s + chr(13) + chr(10))
               s := '         next'
               fwrite(printfile, s + chr(13) + chr(10))
               s := '      endif'
               fwrite(printfile, s + chr(13) + chr(10))
            endif
         endif  
      endif
   next
return("")

function incltb7()
   local s, n, ar
   s := 'use '  + lower(filename) + ' index ' + lower(filename)
   ar := "abcd"
   for n := 1 to 4
      if file(filename + substr(ar, n, 1) + ".ntx")
         s += ', ' + lower(filename) + substr(ar, n, 1)
      endif
   next
   fwrite(printfile, s + chr(13) + chr(10))
return("")

function incltb8()
   local s, n, m
   //  init
   for n:= 1 to len(struct)
      s := ''
      s += '   self:'
      s += struct[n, 2]
      s += ' := '
      if struct[n, 6] == filename
         do case
            case struct[n, 3] = "C"
               s += '""'
            case struct[n, 3] = "N"
               s += '0'
               if struct[n, 5] > 0
                  s += '.'
                  for m := 1 to struct[n, 5]
                     s += '0'
                  next
               endif
            case struct[n, 3] = "D"
               s += 'ctod("  -  -    ")'
         endcase
      else
         if struct[n, 7] == "1"
            s += FirstToUpper(struct[n, 2]) + '():New()' 
         else
            s += '{}'
         endif
      endif
      fwrite(printfile, s + chr(13) + chr(10))
   next
return("")

function incltb9(spaces)
   local s
   if logging = 1
      s := space(spaces)
      s += 'self:LogChanges(old_rec, txdate, txtime, ingdat)'
      fwrite(printfile, s + chr(13) + chr(10))
   endif   
return("")

function LookupDbname(classname)
   local old := select(), recptr := recno(), dbname := ""
   select("CLSS")
   go top
   do while .not. eof() 
      /* bug: == classname must be trimmed again */ 
      if clss->APPLID = nApplid .and. rtrim(clss->CLASSNAME) == rtrim(classname)
         dbname := rtrim(clss->DBNAME)
         exit
      endif   
      skip
   enddo
   select(old)
   go recptr
return(dbname)

function GetCollClass(classname)
   local old := select(), retval := ""
   select 0
   use clss
   do while .not. eof() 
      if clss->APPLID = nApplid .and. rtrim(clss->CLASSNAME) == rtrim(classname)
         retval := rtrim(clss->COLLCLASS)
         exit
      endif
      skip
   enddo	
   use
   select(old)
return(retval)

function GetDbName(classname)
   local old := select(), retval := ""
   select 0
   use clss
   do while .not. eof() 
      if clss->APPLID = nApplid .and. rtrim(clss->CLASSNAME) == rtrim(classname)
         retval := rtrim(clss->DBNAME)
         exit
      endif
      skip
   enddo	
   use
   select(old)
return(retval)

function GetClassId(classname)
   local old := select(), retval := 0
   select 0
   use clss
   do while .not. eof() 
      if clss->APPLID = nApplid .and. rtrim(clss->CLASSNAME) == rtrim(classname)
         retval := clss->ID
         exit
      endif
      skip
   enddo	
   use
   select(old)
return(retval)

function GetClassName(collectionclass)
   local old := select(), retval := ""
   select 0
   use clss
   do while .not. eof() 
      if clss->APPLID = nApplid .and. rtrim(clss->COLLCLASS) = rtrim(collectionclass)
         retval := rtrim(clss->CLASSNAME)
         exit
      endif
      skip
   enddo	
   use
   select(old)
return(retval)

function LookupClassOfDbname(dbname)
   local old := select(), retval := ""
   select 0
   use clss
   do while .not. eof() 
      if clss->APPLID = nApplid .and. rtrim(clss->DBNAME) == rtrim(dbname)
         retval := rtrim(clss->CLASSNAME)
         exit
      endif   
      skip
   enddo
   use
   select(old)
return(retval)

function GetForms(forms, s)
   local n, c, form := ""
   for n := 1 to len(s)
      c := substr(s, n, 1)
      if c = ";"
         aadd(forms, form)
         form := ""
      else
         form += c
      endif
   next
   if form != ""
      aadd(forms, form)
   endif
return(forms)




