#include <hmg.ch>

declare window HGF010
declare window HGF012

Function HGF012_OnInit()
   local item
   if HGF010.ACTION.Value = "Update"
      item := HGF010.grid_1.Item(HGF010.grid_1.Value)
      select 0
      use form index form
      seek(item[1])
      HGF012.ID.Value := item[1]
      HGF012.TITLE.Value := TITLE
      HGF012.OBJECTNAME.Value := BASEOBJECT
      use
      select 0
      use ctrl index ctrl
      seek(item[1])
      do while .not. eof() .and. CTRL->APPID+CTRL->WINID = item[1]
         HGF012.grid_1.AddItem({1,rtrim(LABEL),rtrim(OBJECTNAME),rtrim(FIELDNAME),Unblock(INITVALUE), ;
         VISIBLE,READONLY,1,rtrim(ITEMS),ONCHANGE,ONACTION,AUTHLEVEL,FIELDID})
         skip
      enddo
      use
      HGF012.ID.Enabled := .F.
      HGF012.TITLE.SetFocus()
   endif   
Return nil

Function HGF012_OnAdd()
   load window HGF112
   HGF112.Activate
Return nil

Function HGF012_OnDelete()
   if HGF012.grid_1.Value[1] = 0
      MsgInfo("Svp eerst control uit lijst selecteren")
      return(nil)
   endif
   HGF012.grid_1.DeleteItem(HGF012.grid_1.Value[1])
Return nil

Function HGF012_OnUp()
   local item := array(14), item1, item2, row
   if HGF012.grid_1.Value[1] > 1
      row := HGF012.grid_1.Value[1]
      item1 := HGF012.grid_1.Item(row - 1)
      item2 := HGF012.grid_1.Item(row)
      acopy(item1, item)
	   acopy(item2, item1)
      acopy(item, item2)
      HGF012.grid_1.Item(row - 1) := item1
      HGF012.grid_1.Item(row) := item2
      HGF012.grid_1.Value[1] := row - 1
   endif
   // _HMG_DOGRIDREFRESH(GetControlIndex("grid_1", "HGF012"), .T.)
Return nil

Function HGF012_OnDown()
   local item := array(14), row
   if HGF012.grid_1.Value[1] < HGF012.grid_1.ItemCount
      row := HGF012.grid_1.Value[1]
      item1 := HGF012.grid_1.Item(row)
      item2 := HGF012.grid_1.Item(row + 1)
      acopy(item2, item)
	   acopy(item1, item2)
      acopy(item, item1)
      HGF012.grid_1.Item(row) := item1
      HGF012.grid_1.Item(row + 1) := item2
      HGF012.grid_1.Value[1] := row + 1
   endif   
   // _HMG_DOGRIDREFRESH(GetControlIndex("grid_1", "HGF012"), .T.)   
Return nil

Function HGF012_OnApply()
   local n, item, seqno
   select 0
   use form index form
   if HGF010.ACTION.Value = "Add"
      AddRec(1)
      replace APPID     with substr(HGF012.ID.Value, 1, 2) 
      replace WINID     with substr(HGF012.ID.Value, 3)
   else
      RecLock(1)
   endif   
   replace TITLE        with HGF012.TITLE.Value
   replace BASEOBJECT   with HGF012.OBJECTNAME.Value
   unlock
   use

   select 0
   use ctrl index ctrl
   // delete verwijderde items
   seek substr(HGF012.ID.Value,1,6)
   do while .not. eof() .and. CTRL->APPID+CTRL->WINID = HGF012.ID.Value
      // lookup in items
      for n := 1 to HGF012.grid_1.ItemCount
         item := HGF012.grid_1.Item(n)
         if CTRL->FIELDID = item[13]
            exit
         endif
      next      
      if n > HGF012.grid_1.ItemCount
         // delete
         Reclock(1)
         Delete
         unlock
      endif
      skip
   enddo
   // add/update vanuit items
   seqno := 1
   for n := 1 to HGF012.grid_1.ItemCount
      // lookup in db
      item := HGF012.grid_1.Item(n)
      seek substr(HGF012.ID.Value,1,6) + str(item[13], 2)
      if found()
         RecLock(1)
      else
         Addrec(1)
         replace APPID        with substr(HGF012.ID.Value, 1, 2) 
         replace WINID        with substr(HGF012.ID.Value, 3) 
      endif  
      replace CTRLTYPE     with item[1]
      replace LABEL        with item[2]
      replace OBJECTNAME   with item[3]
      replace FIELDNAME    with item[4]
      replace INITVALUE    with item[5]
      replace VISIBLE      with item[6]
      replace READONLY     with item[7]
      replace ALIGNMENT    with item[8]
      replace ITEMS        with item[9]
      replace ONCHANGE     with item[10]
      replace ONACTION     with item[11]
      replace AUTHLEVEL    with item[12]
      replace FIELDID      with seqno // tbv sort
      unlock
      seqno++
   next
   use
   HGF012.Hide
   HGF012.Release
Return nil

Function HGF012_OnCancel()
   HGF012_OnInit()
Return nil
