/*
This source code has been generated with HMGGEN - Harbour Application Generator.
Please do not remove the BEGIN and END tags and place your own code between the
predefined BEGIN and END tags.
*/

#include "hmg.ch"

declare window HGO220
/* BEGIN */
declare window HGO210
declare window HGO230
/* END */

function HGO220_OnInit()
    local n, aObjects := {}, oRule
    HGO220.grid_1.DeleteAllItems
/* BEGIN */
   aObjects := class:rules
/* END */
    for n := 1 to len(aObjects)
        oRule := aObjects[n]
        HGO220.grid_1.AddItem({ ;
            oRule:descrCondition, ;
            oRule:descrAction, ;
            oRule:numberSequence, ;
            oRule:id ;
        })
    next
/* BEGIN */
/* END */
return(nil)

function HGO220_OnAdd()
/* BEGIN */
   rule := Rule():New()
   if IsWindowDefined(HGO230)
      HGO230.Release
   endif   
   load window HGO230
   HGO230.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function HGO220_update_OnUpdate()
/* BEGIN */
   local aItem
   if HGO220.grid_1.Value = 0
      MsgInfo("Please select a rule first")
      HGO220.grid_1.SetFocus
      return(nil)
   endif   
   aItem := HGO220.grid_1.Item(HGO220.grid_1.Value)
   rule := Rules():Get(aItem[4], Rule():New(), "rule")
   if IsWindowDefined(HGO230)
      HGO230.Release
   endif   
   load window HGO230
   HGO230.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function HGO220_OnDelete()
/* BEGIN */
   local aItem
   if HGO220.grid_1.Value = 0
      MsgInfo("Please select a rule first")
      HGO220.grid_1.SetFocus
      return(nil)
   endif   
   aItem := HGO220.grid_1.Item(HGO220.grid_1.Value)
   rule := Rules():Get(aItem[4], Rule():New(), "rule")
   rule:deleted := "Y"
   rule:Save(date(), time(), userprofile:userid, date())
   HGO220.grid_1.DeleteItem(HGO220.grid_1.Value)
/* END */
/* BEGIN */
/* END */
return(nil)

function HGO220_OnUp()
/* BEGIN */
   local item := array(4), item1, item2, row, seqno1, seqno2, txdate := date(), txtime := time()
   if HGO220.grid_1.Value > 1
      row := HGO220.grid_1.Value
      item1 := HGO220.grid_1.Item(row - 1)
      item2 := HGO220.grid_1.Item(row)
      seqno1 := item1[3]
      seqno2 := item2[3]
      acopy(item1, item)
	   acopy(item2, item1)
      acopy(item, item2)
      item1[3] := seqno1
      item2[3] := seqno2
      HGO220.grid_1.Item(row - 1) := item1
      HGO220.grid_1.Item(row) := item2
      HGO220.grid_1.Value := row - 1
      /* update seqno */
      item1 := HGO220.grid_1.Item(row - 1)
      rule := Rules():Get(item1[4], Rule():New(), "rule")
      rule:numberSequence := item1[3]
      rule:Save(txdate, txtime, userprofile:userid, txdate)
      item2 := HGO220.grid_1.Item(row)
      rule := Rules():Get(item2[4], Rule():New(), "rule")
      rule:numberSequence := item2[3]
      rule:Save(txdate, txtime, userprofile:userid, txdate)
   endif
/* END */
/* BEGIN */
/* END */
return(nil)

function HGO220_OnDown()
/* BEGIN */
   local item := array(4), row, seqno1, seqno2, txdate := date(), txtime := time()
   if HGO220.grid_1.Value < HGO220.grid_1.ItemCount
      row := HGO220.grid_1.Value
      item1 := HGO220.grid_1.Item(row)
      item2 := HGO220.grid_1.Item(row + 1)
      seqno1 := item1[3]
      seqno2 := item2[3]
      acopy(item2, item)
	   acopy(item1, item2)
      acopy(item, item1)
      item1[3] := seqno1
      item2[3] := seqno2
      HGO220.grid_1.Item(row) := item1
      HGO220.grid_1.Item(row + 1) := item2
      HGO220.grid_1.Value := row + 1
      /* update seqno */
      item1 := HGO220.grid_1.Item(row)
      rule := Rules():Get(item1[4], Rule():New(), "rule")
      rule:numberSequence := item1[3]
      rule:Save(txdate, txtime, userprofile:userid, txdate)
      item2 := HGO220.grid_1.Item(row + 1)
      rule := Rules():Get(item2[4], Rule():New(), "rule")
      rule:numberSequence := item2[3]
      rule:Save(txdate, txtime, userprofile:userid, txdate)
   endif   
/* END */
/* BEGIN */
/* END */
return(nil)

function HGO220_OnClose()
/* BEGIN */
/* END */
return(.T.)

/* BEGIN */
/* END */
