/*
This source code has been generated with HMGGEN - Harbour Application Generator.
Please do not remove the BEGIN and END tags and place your own code between the
predefined BEGIN and END tags.
*/

#include "hmg.ch"

declare window HGP110
/* BEGIN */
declare window HG0000
declare window HGP120
/* END */

function HGP110_OnInit()
    local n, aObjects := {}, oProcess
    HGP110.grid_1.DeleteAllItems
/* BEGIN */
   nPseudoId := -1
   aPseudoId := {}
   aObjects := Processes():Find(nApplid, {})
/* END */
    for n := 1 to len(aObjects)
        oProcess := aObjects[n]
        HGP110.grid_1.AddItem({ ;
            oProcess:nameProcess, ;
            oProcess:id ;
        })
    next
/* BEGIN */
/* END */
return(nil)

function HGP110_OnSelect()
/* BEGIN */
   local aItem
   if HGP110.grid_1.Value = 0
      MsgInfo("Please select a process first")
      HGP110.grid_1.SetFocus()
      return(nil)
   endif
   aItem := HGP110.grid_1.Item(HGP110.grid_1.Value)
   HG0000.StatusBar.Item(1) := app  
   HG0000.StatusBar.Item(2) := aItem[2]  
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP110_OnAdd()
/* BEGIN */
   local item1
   HGP110.grid_1.Value := 0
   process := Process():New()
   process:id := GetPseudoId()
   if Iswindowdefined(HGP120)
     HGP120.Release()
   endif   
   load window HGP120
   HGP120.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP110_update_OnUpdate()
/* BEGIN */
   local aItem
   if HGP110.grid_1.Value = 0
      MsgInfo("Please select a process first")
      HGP110.grid_1.SetFocus()
      return(nil)
   endif
   aItem := HGP110.grid_1.Item(HGP110.grid_1.Value)
   process := application:processes[ascan(application:processes, {|x|x:id = aItem[2]})]
   if Iswindowdefined(HGP120)
      HGP120.Release()
   endif   
   load window HGP120
   HGP120.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP110_OnDelete()
/* BEGIN */
   local aItem, txdate := date(), txtime := time(), p, d, na, n, m
   if MsgYesNo("are you sure ?")
      aItem := HGP110.grid_1.Item(HGP110.grid_1.Value)
      p := Processes():Get(aItem[2], Process():New(), "process")
      /* cascading delete */
      for n := 1 to len(p:activityDefinitions)
         d := p:activityDefinitions[n]
         for m := 1 to len(d:nextActivities)
            na := d:nextActivities[m]
            na:deleted := "Y"
            na:Save(txdate, txtime, userprofile:userid, txdate)
         next
         d:deleted := "Y"
         d:Save(txdate, txtime, userprofile:userid, txdate)
      next   
      p:deleted := "Y"
      p:Save(date(), time(), userprofile:userid, date())
      HGP110.grid_1.DeleteItem(HGP110.grid_1.Value)
   endif
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP110_OnClose()
/* BEGIN */
/* END */
return(.T.)

/* BEGIN */
/* END */
