/*
This source code has been generated with HMGGEN - Harbour Application Generator.
Please do not remove the BEGIN and END tags and place your own code between the
predefined BEGIN and END tags.
*/

#include "hmg.ch"

declare window HGP120
/* BEGIN */
declare window HGP110
declare window HGP130
/* END */

function HGP120_OnInit()
    local n, bCondition := {||process:id = 0}
    HGP120.grid_1.DeleteAllItems
/* BEGIN */
   HGP120.UPDATED.Value := "N"
   bCondition := {||HGP110.grid_1.Value = 0}
/* END */
    if eval(bCondition)
        HGP120.PROCOMS.value := ""
        HGP120.PROCCODE.value := ""
    else
        HGP120.PROCOMS.value := process:nameProcess
        HGP120.PROCCODE.value := process:codeProcess
        for n := 1 to len(process:activityDefinitions)
            HGP120.grid_1.AddItem({ ;
                process:activityDefinitions[n]:nameActivity, ;
                ComboLookupDescr("BEHANDTEAM", process:activityDefinitions[n]:codeTeam), ;
                ComboLookupDescr("ROL", str(process:activityDefinitions[n]:codeRole)), ;
                if(process:activityDefinitions[n]:indicAuto = "Y", "Yes", "No"), ;
                if(process:activityDefinitions[n]:indic4Eyes = "Y", "Yes", "No"), ;
                process:activityDefinitions[n]:numberOfMonthsRecallterm, ;
                process:activityDefinitions[n]:numberSequence, ;
                process:activityDefinitions[n]:id ;
            })
        next
    endif
/* BEGIN */
   select 0
   if eval(bCondition)
      activityDefinition := ActivityDefinition():New()
      activityDefinition:id := GetPseudoId()
      activityDefinition:nameActivity := "Open case"
      activityDefinition:codeTeam := "SYS"
      activityDefinition:codeRole := 99
      activityDefinition:indicAuto := "Y"
      activityDefinition:indic4Eyes := "N"
      activityDefinition:numberOfMonthsRecallterm := 0
      activityDefinition:descrInitialStatus := "Case not opened"
      activityDefinition:descrActionBlock := ""
      activityDefinition:numberSequence := 1
      aadd(process:activityDefinitions, activityDefinition)
      HGP120.grid_1.AddItem({"Open case", "System", "System", "Yes", "No", 0, 1, activityDefinition:id})
      activityDefinition := ActivityDefinition():New() 
      activityDefinition:id := GetPseudoId()
      activityDefinition:nameActivity := "Close case"
      activityDefinition:codeTeam := "SYS"
      activityDefinition:codeRole := 99
      activityDefinition:indicAuto := "Y"
      activityDefinition:indic4Eyes := "N"
      activityDefinition:numberOfMonthsRecallterm := 0
      activityDefinition:descrInitialStatus := "Case not closed"
      activityDefinition:descrActionBlock := "Close case"
      activityDefinition:numberSequence := 2
      aadd(process:activityDefinitions, activityDefinition)
      HGP120.grid_1.AddItem({"Close case", "System", "System", "Yes", "No", 0, 2, activityDefinition:id})
   else   
      HGP120.grid_1.DeleteAllItems
      for n := 1 to len(process:activityDefinitions)
         activityDefinition := process:activityDefinitions[n]
         if activityDefinition:deleted != "Y"
            HGP120.grid_1.AddItem({activityDefinition:nameActivity, ;
               ComboLookupDescr("BEHANDTEAM", activityDefinition:codeTeam), ;
               ComboLookupDescr("ROL", str(activityDefinition:codeRole)), ;
               if(activityDefinition:indicAuto = "Y", "Yes", "No"), ;
               if(activityDefinition:indic4Eyes = "Y", "Yes", "No"), ;
               activityDefinition:numberOfMonthsRecallterm, ;
               activityDefinition:numberSequence, activityDefinition:id})
         endif      
      next
   endif   
/* END */
return(nil)

function HGP120_OnUpdate(process)
/* BEGIN */
    if(process:nameProcess != HGP120.PROCOMS.value, HGP120.UPDATED.Value := "Y", nil)
    if(process:codeProcess != HGP120.PROCCODE.value, HGP120.UPDATED.Value := "Y", nil)
/* END */
    process:nameProcess := HGP120.PROCOMS.value
    process:codeProcess := HGP120.PROCCODE.value
/* BEGIN */
/* END */
return(nil)

function HGP120_grid_1_OnAdd()
/* BEGIN */
   local aItem
   HGP120.grid_1.Value := 0
   aItem := HGP120.grid_1.Item(HGP120.grid_1.ItemCount)
   activityDefinition := activityDefinition():New()
   activityDefinition:id := GetPseudoId()
   activityDefinition:numberSequence := aItem[7] + 1
   load window HGP130
   HGP130.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP120_grid_1_OnUpdate()
/* BEGIN */
   local aItem, n
   if HGP120.grid_1.Value = 0
      MsgInfo("Please select an activity first")
      HGP120.grid_1.SetFocus()
      return(nil)
   endif   
   aItem := HGP120.grid_1.Item(HGP120.grid_1.Value)
   n := ascan(process:activityDefinitions, {|x|x:id = aItem[8]})
   activityDefinition := process:activityDefinitions[n]
   load window HGP130
   HGP130.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP120_grid_1_OnDelete()
/* BEGIN */
   local aItem, n
   if HGP120.grid_1.Value = 0
      MsgInfo("Please select an activity first")
      HGP120.grid_1.SetFocus()
      return(nil)
   endif   
   if MsgYesNo("Are you sure?", "Confirmation")
      aItem := HGP120.grid_1.Item(HGP120.grid_1.Value)
      n := ascan(process:activityDefinitions, {|x|x:id = aItem[8]})
      activityDefinition := process:activityDefinitions[n]
      /* cascading delete */
      for n := 1 to len(activityDefinition:nextActivities)
         na := activityDefinition:nextActivities[n]
         na:deleted := "Y"
      next
      activityDefinition:deleted := "Y"
      HGP120.grid_1.DeleteItem(HGP120.grid_1.Value)
   endif  
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP120_grid_1_OnUp()
/* BEGIN */
   local item := array(8), item1, item2, row, seqno1, seqno2, d, pos1, pos2
   if HGP120.grid_1.Value > 1
      row := HGP120.grid_1.Value
      item1 := HGP120.grid_1.Item(row - 1)
      item2 := HGP120.grid_1.Item(row)
      seqno1 := item1[7]
      seqno2 := item2[7]
      acopy(item1, item)
	   acopy(item2, item1)
      acopy(item, item2)
      item1[7] := seqno1
      item2[7] := seqno2
      HGP120.grid_1.Item(row - 1) := item1
      HGP120.grid_1.Item(row) := item2
      HGP120.grid_1.Value := row - 1
      /* update exchanged seqno's */
      pos1 := ascan(process:activityDefinitions, {|x|x:numberSequence = seqno1})
      pos2 := ascan(process:activityDefinitions, {|x|x:numberSequence = seqno2})
      d := process:activityDefinitions[pos1]
      process:activityDefinitions[pos1] := process:activityDefinitions[pos2]
      process:activityDefinitions[pos2] := d
      process:activityDefinitions[pos1]:numberSequence := seqno1
      process:activityDefinitions[pos2]:numberSequence := seqno2
   endif
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP120_grid_1_OnDown()
/* BEGIN */
   local item := array(8), row, seqno1, seqno2, d, pos1, pos2
   if HGP120.grid_1.Value < HGP120.grid_1.ItemCount
      row := HGP120.grid_1.Value
      item1 := HGP120.grid_1.Item(row)
      item2 := HGP120.grid_1.Item(row + 1)
      seqno1 := item1[7]
      seqno2 := item2[7]
      acopy(item2, item)
	   acopy(item1, item2)
      acopy(item, item1)
      item1[7] := seqno1
      item2[7] := seqno2
      HGP120.grid_1.Item(row) := item1
      HGP120.grid_1.Item(row + 1) := item2
      HGP120.grid_1.Value := row + 1
      /* update exchanged seqno's */
      pos1 := ascan(process:activityDefinitions, {|x|x:numberSequence = seqno1})
      pos2 := ascan(process:activityDefinitions, {|x|x:numberSequence = seqno2})
      d := process:activityDefinitions[pos1]
      process:activityDefinitions[pos1] := process:activityDefinitions[pos2]
      process:activityDefinitions[pos2] := d
      process:activityDefinitions[pos1]:numberSequence := seqno1
      process:activityDefinitions[pos2]:numberSequence := seqno2
   endif   
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP120_OnCancel()
/* BEGIN */
/* END */
   HGP120_OnInit()
/* BEGIN */
/* END */
return(nil)

function HGP120_OnApply()
/* BEGIN */
/* END */
   HGP120_OnUpdate(process)
/* BEGIN */
   HGP120_Save()
   HGP120.Release
/* END */
return(nil)

function HGP120_OnClose()
/* BEGIN */
   if HGP120.UPDATED.Value = "Y"
      if MsgYesNo("Apply changes ?", "Confirmation")
         HGP120_Save()
      endif
   endif   
/* END */
return(.T.)

/* BEGIN */
function HGP120_Save()
   local txdate := date(), txtime := time(), nId := process:id, d, na, aItem
   process:idApplication := nApplid
   process:Save(txdate, txtime, userprofile:userid, txdate)
   /* first save all activitydefinitions */
   for n := 1 to len(process:activityDefinitions)
      d := process:activityDefinitions[n]
      d:process:id := process:id
      d:Save(txdate, txtime, userprofile:userid, txdate)
   next   
   for n := 1 to len(process:activityDefinitions)
      d := process:activityDefinitions[n]
      for m := 1 to len(d:nextActivities)
         na := d:nextActivities[m]
         na:activityDefinition:id := d:id
         na:Save(txdate, txtime, userprofile:userid, txdate)
      next   
   next
   if nId <= 0
      HGP110.grid_1.AddItem({process:nameProcess, process:id})
      aadd(application:processes, process)
   else
      aItem := HGP110.grid_1.Item(HGP110.grid_1.Value)
      aItem[1] := process:nameProcess
      HGP110.grid_1.Item(HGP110.grid_1.Value) := aItem
   endif
   HGP120.UPDATED.Value := "N"
return(nil)
/* END */
