/*
This source code has been generated with HMGGEN - Harbour Application Generator.
Please do not remove the BEGIN and END tags and place your own code between the
predefined BEGIN and END tags.
*/

#include "hmg.ch"

declare window HGP130
/* BEGIN */
declare window HGP120
/* END */

function HGP130_OnInit()
    local n, bCondition := {||activityDefinition:id = 0}
    HGP130.grid_1.DeleteAllItems
/* BEGIN */
   bCondition := {||HGP120.grid_1.Value = 0}
/* END */
    ComboLoadItems("BEHANDTEAM", "BEHANDTEAM", "HGP130")
    ComboLoadItems("ROL", "ROL", "HGP130")
    if eval(bCondition)
        HGP130.ACTOMS.value := ""
        HGP130.BEHANDTEAM.value := ComboLookupDefault("BEHANDTEAM", "BEHANDTEAM", "HGP130")
        HGP130.ROL.value := ComboLookupDefault("ROL", "ROL", "HGP130")
        HGP130.INDICAUTO.value := 2
        HGP130.INDIC4OGEN.value := 2
        HGP130.RAPPTERM.value := 0
        HGP130.INITSTATUS.value := ""
        HGP130.ACTBLOCK.value := ""
    else
        HGP130.ACTOMS.value := activityDefinition:nameActivity
        HGP130.BEHANDTEAM.value := ComboLookupValue("BEHANDTEAM", "BEHANDTEAM", "HGP130", activityDefinition:codeTeam)
        HGP130.ROL.value := ComboLookupValue("ROL", "ROL", "HGP130", str(activityDefinition:codeRole, 2))
        HGP130.INDICAUTO.value := if(activityDefinition:indicAuto = "Y", 1, 2)
        HGP130.INDIC4OGEN.value := if(activityDefinition:indic4Eyes = "Y", 1, 2)
        HGP130.RAPPTERM.value := activityDefinition:numberOfMonthsRecallterm
        HGP130.INITSTATUS.value := activityDefinition:descrInitialStatus
        HGP130.ACTBLOCK.value := activityDefinition:descrActionBlock
        for n := 1 to len(activityDefinition:nextActivities)
            if activityDefinition:nextActivities[n]:deleted != "Y"
               oms := LookupNameActivity(activityDefinition:nextActivities[n]:idNextActivity, process)
               HGP130.grid_1.AddItem({ ;
                  activityDefinition:nextActivities[n]:descrStatus, ;
                  activityDefinition:nextActivities[n]:descrCondition, ;
                  oms, ;
                  activityDefinition:nextActivities[n]:id ;
               })
            endif   
        next
    endif
/* BEGIN */
/*
   Notes:
   After generating update this file manually as follows:
        for n := 1 to len(activityDefinition:nextActivities)
            if activityDefinition:nextActivities[n]:deleted != "Y"
               oms := LookupNameActivity(activityDefinition:nextActivities[n]:idNextActivity, process)
               HGP130.grid_1.AddItem({ ;
                  activityDefinition:nextActivities[n]:descrStatus, ;
                  activityDefinition:nextActivities[n]:descrCondition, ;
                  oms, ;
                  activityDefinition:nextActivities[n]:id ;
               })
            endif   
        next

        HGP130.ROL.value := ComboLookupValue("ROL", "ROL", "HGP130", str(activityDefinition:codeRole, 2))
*/
    HGP130.ACTOMS.SetFocus    
/* END */
return(nil)

function HGP130_OnUpdate(activityDefinition)
/* BEGIN */
    if(activityDefinition:nameActivity != HGP130.ACTOMS.value, HGP120.UPDATED.Value := "Y", nil)
    if(activityDefinition:codeTeam != ComboGetCode("BEHANDTEAM", "BEHANDTEAM", "HGP130"), HGP120.UPDATED.Value := "Y", nil)
    if(activityDefinition:codeRole != val(ComboGetCode("ROL", "ROL", "HGP130")), HGP120.UPDATED.Value := "Y", nil)
    if(activityDefinition:indicAuto != if(HGP130.INDICAUTO.value = 1, "Y", "N"), HGP120.UPDATED.Value := "Y", nil)
    if(activityDefinition:indic4Eyes != if(HGP130.INDIC4OGEN.value = 1, "Y", "N"), HGP120.UPDATED.Value := "Y", nil)
    if(activityDefinition:numberOfMonthsRecallterm != HGP130.RAPPTERM.value, HGP120.UPDATED.Value := "Y", nil)
    if(activityDefinition:descrInitialStatus != HGP130.INITSTATUS.value, HGP120.UPDATED.Value := "Y", nil)
    if(activityDefinition:descrActionBlock != HGP130.ACTBLOCK.value, HGP120.UPDATED.Value := "Y", nil)
/* END */
    activityDefinition:nameActivity := HGP130.ACTOMS.value
    activityDefinition:codeTeam := ComboGetCode("BEHANDTEAM", "BEHANDTEAM", "HGP130")
    activityDefinition:codeRole := val(ComboGetCode("ROL", "ROL", "HGP130"))
    activityDefinition:indicAuto := if(HGP130.INDICAUTO.value = 1, "Y", "N")
    activityDefinition:indic4Eyes := if(HGP130.INDIC4OGEN.value = 1, "Y", "N")
    activityDefinition:numberOfMonthsRecallterm := HGP130.RAPPTERM.value
    activityDefinition:descrInitialStatus := HGP130.INITSTATUS.value
    activityDefinition:descrActionBlock := HGP130.ACTBLOCK.value
/* BEGIN */
/* END */
return(nil)

function HGP130_grid_1_OnAdd()
/* BEGIN */
   HGP130.grid_1.Value := 0
   nextActivity := nextActivity():New()
   nextActivity:id := GetPseudoId()
   load window HGP140
   HGP140.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP130_grid_1_OnUpdate()
/* BEGIN */
   local aItem, n
   if HGP130.grid_1.Value = 0
      MsgInfo("Please select a follow up activity first")
      HGP130.grid_1.SetFocus()
      return(nil)
   endif   
   aItem := HGP130.grid_1.Item(HGP130.grid_1.Value)
   n := ascan(activityDefinition:nextActivities, {|x|x:id = aItem[4]})
   nextActivity := activityDefinition:nextActivities[n]
   load window HGP140
   HGP140.Activate()
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP130_grid_1_OnDelete()
/* BEGIN */
local item1, n, nextActivity
   if HGP130.grid_1.Value = 0
      MsgInfo("Please select a follow up activity first")
      HGP130.grid_1.SetFocus()
      return(nil)
   endif   
   if MsgYesNo("Are you sure?", "Confirmation")
      item1 := HGP130.grid_1.Item(HGP130.grid_1.Value)
      n := ascan(activityDefinition:nextActivities, {|x|x:id = item1[4]})
      nextActivity := activityDefinition:nextActivities[n]
      nextActivity:deleted := "Y"
      HGP130.grid_1.DeleteItem(HGP130.grid_1.Value)
      /* to synchronize objects with grid, object has to be deleted as well */
      adel(activityDefinition:nextActivities, n)
      asize(activityDefinition:nextActivities, len(activityDefinition:nextActivities) - 1)
   endif  
   HGP130_OnInit()
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP130_OnCancel()
/* BEGIN */
/* END */
   HGP130_OnInit()
/* BEGIN */
/* END */
return(nil)

function HGP130_OnOk()
/* BEGIN */
   local aItem
   HGP130_OnUpdate(activityDefinition)
   if HGP120.grid_1.Value = 0
      aadd(process:activityDefinitions, activityDefinition)
      HGP120.grid_1.AddItem({ ;
         activityDefinition:nameActivity, ;
         ComboLookupDescr("BEHANDTEAM", activityDefinition:codeTeam), ;
         ComboLookupDescr("ROL", str(activityDefinition:codeRole, 2)), ;
         if(activityDefinition:indicAuto = "Y", "Yes", "No"), ;
         if(activityDefinition:Indic4Eyes = "Y", "Yes", "No"), ;
         activityDefinition:numberOfMonthsRecallterm, ;
         activityDefinition:numberSequence, activityDefinition:id ;
      })
      aItem := HGP120.grid_1.Item(HGP120.grid_1.ItemCount)
      activityDefinition := activityDefinition():New()
      activityDefinition:id := GetPseudoId()
      activityDefinition:numberSequence := aItem[7] + 1
      HGP130_OnInit()   
   else
      aItem := HGP120.grid_1.Item(HGP120.grid_1.Value)
      aItem[1] := activityDefinition:nameActivity
      aItem[2] := ComboLookupDescr("BEHANDTEAM", activityDefinition:codeTeam)
      aItem[3] := ComboLookupDescr("ROL", str(activityDefinition:codeRole, 2))
      aItem[4] := if(activityDefinition:indicAuto = "Y", "Yes", "No")
      aItem[5] := if(activityDefinition:Indic4Eyes = "Y", "Yes", "No")
      aItem[6] := activityDefinition:numberOfMonthsRecallterm
      HGP120.grid_1.Item(HGP120.grid_1.Value) := aItem
      HGP130.Release
   endif
/* END */
/* BEGIN */
/* END */
return(nil)

function HGP130_OnClose()
/* BEGIN */
/* END */
return(.T.)

/* BEGIN */
/* END */
