/*
   This source code has been generated with HMGGEN - Harbour Application Generator.
   Please do not remove the BEGIN and END tags and place your own code between the 
   predefined BEGIN and END tags.	
*/

#include <hmg.ch>
#include "hbclass.ch"
/* BEGIN */
/* END */

class Forms
   Method Init() constructor
   Method Find(applid, forms, refdat)
   Method Get(id, form, requestor, refdat)
   /* BEGIN */
   /* END */
endclass   

Method Init() class Forms
return self

Method Find(applid, forms, refdat) class Forms
   local old := select(), obj := {}
   select 0
   use form index forma 
   /* BEGIN */
   /* END */	
   if pcount() < 3 .or. empty(refdat)
      seek str(applid, 10)
      do while .not. eof() .and. form->APPLID = applid
         aadd(forms, Form():New():Transfer()) 
         skip
      enddo
   else
      // time travelling
      set deleted off
      seek str(applid, 10)
      do while .not. eof() .and. form->APPLID = applid
         obj := SaveRec(obj)
         DbfLogRollback("FORM", form->ID, refdat)
         if form->DELETED == "N" .and. form->INGDAT <= refdat 
            aadd(forms, Form():New():Transfer()) 
         endif
         RestRec(obj)
         skip
      enddo
      set deleted on
   endif
   use
   select(old)
return forms
   
Method Get(id, form, requestor, refdat) class Forms
   local old := select(), n, obj := {}
   if requestor != "old"
      select 0
      use FORM index FORM
   endif
   seek str(id, 10)
   if found()
      if pcount() > 3 .and. !empty(refdat)
         obj := SaveRec(obj)
         DbfLogRollback("FORM", form->ID, refdat)
         form:Transfer()	
         RestRec(obj)
      else
         form:Transfer()	
      endif
   endif
   if requestor != "old" 
      if requestor != "application"
         Applications():Get(form->APPLID, form:application, "form", refdat)
      endif
      if requestor != "control"
         Controls():Find(id, form:controls, refdat)
         for n := 1 to len(form:controls)
            Controls():Get(form:controls[n]:id, form:controls[n], "form", refdat)
         next
      endif
      /* BEGIN */
      /* END */
      use
   endif  
   select(old)
return form

class Form
   data id
   data codeForm
   data nameForm
   data nameFormEnglish
   data nameBaseObject
   data application
   data controls
   data deleted
   data userid
   data txdate     
   data txtime
   Method Init() constructor
   Method Save(txdate, txtime, userid, ingdat)
   Method Equals(old) protected
   Method Transfer()
   Method Replace(txdate, txtime, userid) protected
   Method LogChanges(old_rec, txdate, txtime, ingdat) protected
   /* BEGIN */
   /* END */
endclass

Method Init() class Form
   self:id := 0
   self:codeForm := ""
   self:nameForm := ""
   self:nameFormEnglish := ""
   self:nameBaseObject := ""
   self:application := Application():New()
   self:controls := {}
   self:deleted := "N"
   self:userid := ""
   self:txdate := ctod(" -  -    ")     
   self:txtime := ""
   /* BEGIN */
   /* END */
return self

Method Save(txdate, txtime, userid, ingdat) 
local id, newId, bChanged, old_rec, old := select(), aBrokenRules := {}
select 0
use form index form, forma
bChanged := .F.
id = self:id
if id <= 0
   // insert request
else
   // update or delete request
   old_rec = forms():Get(id, form():New(), "old")
   if found()
      // check whether content has changed
      if self:Equals(old_rec)
         // do nothing
      else 
         // check concurrent update
         if self:txdate = old_rec:txdate .and. self:txtime = old_rec:txtime
            if self:deleted = "Y"
               RecLock(1)
               form->DELETED := self:deleted
               form->USERID := userid
               form->TXDATE := txdate
               form->TXTIME := txtime
               delete
               unlock
               self:LogChanges(old_rec, txdate, txtime, ingdat)
            else
               bChanged := .T.
            endif
         else 
            MsgInfo("record has been updated by: " + old_rec:userid)
         endif
      endif
   else
      // defensive programming
      MsgInfo("record deleted by other user")
   endif
endif
if id <= 0 .or. bChanged
   // evaluation of business rules, use aBrokenRules
   /* BEGIN */
   /* END */
   // end evaluation of business rules
   if empty(aBrokenRules)
      if id <= 0	
         newId = DbfGetID("FORM")
         self:id = newId
         AddRec(1)	
         form->ID := self:id
         /* BEGIN */
      form->APPLID := self:application:id
         /* END */
         self:Replace(txdate, txtime, userid)
         unlock
      else
         RecLock(1)
         self:Replace(txdate, txtime, userid)
         unlock
         self:LogChanges(old_rec, txdate, txtime, ingdat)
      endif
      self:userid := userid
      self:txdate := txdate
      self:txtime := txtime
   endif
endif
use
select(old)
return(aBrokenRules)

Method Equals(old_rec) class Form
local retval := .T.
   set exact on
   if self:codeForm != old_rec:codeForm
      retval := .F.
   endif
   if self:nameForm != old_rec:nameForm
      retval := .F.
   endif
   if self:nameFormEnglish != old_rec:nameFormEnglish
      retval := .F.
   endif
   if self:nameBaseObject != old_rec:nameBaseObject
      retval := .F.
   endif
   if self:deleted != old_rec:deleted
      retval := .F.
   endif
   set exact off
return(retval)
 
Method Transfer() class Form
   self:id := form->ID 	
   self:codeForm := rtrim(form->FORMCODE)
   self:nameForm := rtrim(form->TITLE)
   self:nameFormEnglish := rtrim(form->TITLEUK)
   self:nameBaseObject := rtrim(form->BASEOBJECT)
   self:deleted := form->DELETED 	
   self:userid := form->USERID 	
   self:txdate := form->TXDATE 	
   self:txtime := form->TXTIME 	
return(self)

Method Replace(txdate, txtime, userid) class Form
   form->FORMCODE := self:codeForm
   form->TITLE := self:nameForm
   form->TITLEUK := self:nameFormEnglish
   form->BASEOBJECT := self:nameBaseObject
   form->DELETED := self:deleted
   form->USERID := userid
   form->TXDATE := txdate
   form->TXTIME := txtime
return(nil)

Method LogChanges(old_rec, txdate, txtime, ingdat) class Form
   if self:codeForm != old_rec:codeForm
      DbfLogAdd(alias(), "FORMCODE", old_rec:id, old_rec:codeForm, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameForm != old_rec:nameForm
      DbfLogAdd(alias(), "TITLE", old_rec:id, old_rec:nameForm, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameFormEnglish != old_rec:nameFormEnglish
      DbfLogAdd(alias(), "TITLEUK", old_rec:id, old_rec:nameFormEnglish, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:nameBaseObject != old_rec:nameBaseObject
      DbfLogAdd(alias(), "BASEOBJECT", old_rec:id, old_rec:nameBaseObject, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
   if self:deleted != old_rec:deleted
      DbfLogAdd(alias(), "DELETED", old_rec:id, old_rec:deleted, old_rec:txdate, old_rec:txtime, ingdat, "00:00:00", old_rec:userid)
   endif
return(nil)

// put here your udf's

/* BEGIN */
/* END */
